/***************************************************************************/
/*                                                                         */
/*				     Graphic User Interface source file								*/
/*																									*/
/*			 Most parts of this file are from me (ZEOGRAD)                    */
/*     You can use it, I trust you not to rip me but I would like to       */
/*     Be contacted if you do so and then quoted where you use this        */
/*     That's all, you can gain as much money as you want with it =)       */
/*                                                                         */
/*		 Well, all of this have been modified so much that it can be         */
/*     considered as part of the Hu-Go! project                            */
/*                                                                         */
/*             (c)1999 Zeograd (Olivier Jolly) Zeograd@caramail.com			*/
/*															  Ojolly@hotmail.com				*/
/***************************************************************************/

// Most of this is still en french, I will change this slowly...

#include "GUI.H"

char selected_rom[128];
// the buffer where the name of the rom will be placed

char initial_path[128];
// prefered path for for searching

char* tmp_buf;
// a general purpose buffer (size 100 chars)

RGB cycle[32];
// Colors to be cycled

const char nb_fadein  = 3;
const char nb_fadeout = 3;
// used to know how many functions do we have

void special_fadein1(BITMAP* to,unsigned xto,unsigned yto,unsigned xmax,unsigned ymax);
void special_fadein2(BITMAP* to,unsigned xto,unsigned yto,unsigned xmax,unsigned ymax);
void special_fadein3(BITMAP* to,unsigned xto,unsigned yto,unsigned xmax,unsigned ymax);
// forward declaration for initialising the following tab

void (*fade_in_proc[3])(BITMAP*,unsigned,unsigned,unsigned,unsigned)=
  {special_fadein1,special_fadein2,special_fadein3};
// Array of function for random calls

void special_fadeout1(unsigned xto,unsigned yto,unsigned xmax,unsigned ymax);
void special_fadeout2(unsigned xto,unsigned yto,unsigned xmax,unsigned ymax);
void special_fadeout3(unsigned xto,unsigned yto,unsigned xmax,unsigned ymax);
// forward declaration for initialising the following tab

void (*fade_out_proc[3])(unsigned,unsigned,unsigned,unsigned)=
  {special_fadeout1,special_fadeout2,special_fadeout3};
// Array of function for random calls


extern int frame;

extern char short_exe_name[];

/*****************************************************************************

    Function: special_fadein1

    Description: fade in with spiral effect
    Parameters: the BITMAP to fade to,
	             xto,yto,xmax,ymax used like in blit
					 used like "blit(screen,to,0,0,xto,yto,xmax,ymax)"
    Return:nothing

*****************************************************************************/


void special_fadein1(BITMAP* to,unsigned xto,unsigned yto,unsigned xmax,unsigned ymax)
  {
	static xinit[] = {0,1,2,3,3,3,3,2,1,0,0,0,1,2,2,1};
	static yinit[] = {0,0,0,0,1,2,3,3,3,3,2,1,1,1,2,2};
	unsigned	x=0,y=0;
	unsigned char index;
	for (index=0;index<16;index++)
	  {
	   for (y=yinit[index];y<ymax;y+=4)
	     for (x=xinit[index];x<xmax;x+=4)
		     putpixel(screen,xto+x,yto+y,getpixel(to,x,y));
      vsync();
     }
	return ;
	}

/*****************************************************************************

    Function: special_fadeout1

    Description: fade out with spiral effect
    Parameters: xto,yto,xmax,ymax used like in blit
					 used like "rectfill(screen,xto,yto,xto+xmax,yto+ymax)"
    Return:nothing

*****************************************************************************/


void special_fadeout1(unsigned xto,unsigned yto,unsigned xmax,unsigned ymax)
  {
	static xinit[] = {0,1,2,3,3,3,3,2,1,0,0,0,1,2,2,1};
	static yinit[] = {0,0,0,0,1,2,3,3,3,3,2,1,1,1,2,2};
	unsigned	x=0,y=0;
	unsigned char index;
	for (index=0;index<16;index++)
	  {
	   for (y=yto+yinit[index];y<yto+ymax;y+=4)
	     for (x=xto+xinit[index];x<xto+xmax;x+=4)
		     putpixel(screen,x,y,0);
      vsync();
     }
	return ;
	}


/*****************************************************************************

    Function: special_fadeout2

    Description: fade out with slide effect
    Parameters: xto,yto,xmax,ymax used like in blit
					 used like "rectfill(screen,xto,yto,xto+xmax,yto+ymax)"
    Return:nothing

*****************************************************************************/


void special_fadeout2(unsigned xto,unsigned yto,unsigned xmax,unsigned ymax)
  {
   int y=0;
	int *diff,*act;
	int index,max_iter = (xmax-xto)/5,iter=0;

	diff=(int*)alloca(sizeof(int)*ymax);
	act=(int*)alloca(sizeof(int)*ymax);
	memset(diff,0,(ymax)*sizeof(int));
	memset(act,0,ymax*sizeof(int));


	while (iter<max_iter)
	  {
	   for (index=0;index<ymax;index++)
        {
		   act[index]+=diff[index]=rand()%3+5;
			if (act[index]>xmax)
			  act[index]=xmax;
        }
	   for (y=yto,index=0;index<ymax;y++,index++)
			hline(screen,xto,y,xto+act[index],0);

      iter++;
      vsync();
     }
	return ;
	}

/*****************************************************************************

    Function: special_fadein2

    Description: fade in with slide effect
    Parameters: xto,yto,xmax,ymax used like in blit
					 used like "blit(screen,to,0,0,xto,yto,xmax,ymax)"
    Return:nothing

*****************************************************************************/


void special_fadein2(BITMAP *to,unsigned xto,unsigned yto,unsigned xmax,unsigned ymax)
  {
   int y=0;
	int *diff,*act;
	int index,max_iter = (xmax-xto)/5,iter=0;

	diff=(int*)alloca(sizeof(int)*ymax);
	act=(int*)alloca(sizeof(int)*ymax);
	memset(diff,0,(ymax)*sizeof(int));
	memset(act,0,(ymax)*sizeof(int));


	while (iter<max_iter)
	  {
	   for (index=0;index<ymax;index++)
        {
		   act[index]+=diff[index]=rand()%3+5;
			if (act[index]>=to->w)
			  act[index]=to->w;
        }

	   for (y=yto,index=0;index<ymax;y++,index++)
				blit(to,screen,to->w-act[index],index,xto,y,act[index],1);

      iter++;
      vsync();
     }
	return ;
	}


/*****************************************************************************

    Function: special_fadein3

    Description: fade in with double slide effect
    Parameters: xto,yto,xmax,ymax used like in blit
					 used like "blit(screen,to,0,0,xto,yto,xmax,ymax)"
    Return:nothing

*****************************************************************************/


void special_fadein3(BITMAP *to,unsigned xto,unsigned yto,unsigned xmax,unsigned ymax)
  {
   int y=0;
	int *diff,*act;
	int index,max_iter = (xmax-xto)/10,iter=0;

	diff=(int*)alloca(sizeof(int)*ymax);
	act=(int*)alloca(sizeof(int)*ymax);
	memset(diff,0,(ymax)*sizeof(int));
	memset(act,0,(ymax)*sizeof(int));

	while (iter<max_iter)
	  {

		for (index=0;index<ymax;index++)
			act[index]+=10;

      for (y=yto,index=0;index<ymax;y+=2,index+=2)
			 blit(to,screen,to->w-act[index],index,xto,y,act[index],1);

	   for (y=yto+1,index=1;index<ymax;y+=2,index+=2)
          blit(to,screen,0,index,xto+xmax-act[index],y,act[index],1);

      iter++;
      vsync();
     }
	return ;
	}


/*****************************************************************************

    Function: special_fadeout3

    Description: fade in with double slide effect
    Parameters: xto,yto,xmax,ymax used like in blit
					 used like "rectfill(screen,xto,yto,xto+xmax,yto+ymax)"
    Return:nothing

*****************************************************************************/


void special_fadeout3(unsigned xto,unsigned yto,unsigned xmax,unsigned ymax)
  {
   int y=0;
	int *diff,*act;
	int index,max_iter = (xmax-xto)/10,iter=0;

	diff=(int*)alloca(sizeof(int)*ymax);
	act=(int*)alloca(sizeof(int)*ymax);
	memset(diff,0,(ymax)*sizeof(int));
	memset(act,0,(ymax)*sizeof(int));

	while (iter<max_iter)
	  {

		for (index=0;index<ymax;index++)
			act[index]+=10;

      for (y=yto,index=0;index<ymax;y+=2,index+=2)
			 hline(screen,act[index]-10,y,act[index],0);

	   for (y=yto+1,index=1;index<ymax;y+=2,index+=2)
			 hline(screen,xto+xmax-act[index]+10,y,xto+xmax-act[index],0);

      iter++;
      vsync();
     }
	return ;
	}


/*****************************************************************************

    Function:  faff

    Description:crapy function for internal use, in fact format a bit a filename
    Parameters:char* im, the raw filename
    Return:a pointer to tmp_buf, loaded with the result

*****************************************************************************/


char* faff(char im[14])
  {
char dummy[14];
strcpy(tmp_buf,"                 ");
if (!im[0])
   return tmp_buf;
else  if (!index(im,'.'))
  return strncpy(tmp_buf,im,8);
      else
        {
			int x=0,y=0;
	      while ((im[(y=x)]!='.') && (x<12))
	        dummy[x]=im[x++];
         while (x<8) dummy[x++]=' ';
	        dummy[8]='.';
         y++;
	      x++;
	      while (im[y])
           dummy[x++]=im[y++];
         dummy[x]=0;
	      return strcpy(tmp_buf,dummy);
	}
  };
/*****************************************************************************

    Function:  add_index

    Description: add info for the filename to the current 'ROM_LIST.HG!'
    Parameters:char* name, the filename to inspect
               char* cur_dir, the current directory
    Return:0 if failed, 1 on success

*****************************************************************************/
int add_index(char* name,char* cur_dir)
{
 unsigned CRC=CRC_file(name);
 unsigned index,no=0xFFFFFFFF;
 FILE* f;
 char* tmp_buf=(char*)alloca(100);

 for (index=0;index<NB_ROM;index++)
	 if (ROM_LIST[index].CRC==CRC)
		{
		  no=index;
		  break;
      }
 if (no==0xFFFFFFFF)
	return 0;

 sprintf(tmp_buf,"%s/ROM_LIST.HG!",cur_dir);
 if (!(f=fopen(tmp_buf,"ab")))
	return 0;

 fwrite(name,1,13,f);
 strcpy(tmp_buf,ROM_LIST[no].name);
 if (strrchr(tmp_buf,'-'))
	*strrchr(tmp_buf,'-')=0;
 tmp_buf[15]=0;

 fwrite(tmp_buf,1,16,f);
 fclose(f);

 return 1;
 }



/*****************************************************************************

    Function:  affiche_choix [lit. draw_choice]

    Description: draws  the current available files & dir
    Parameters: lotta! too many!
    Return: AAAAAAAAAAAAAAArg! Nop', Yep guy!

*****************************************************************************/


void affichechoix(TO_DISPLAY to_display[1500],unsigned short const dirt,unsigned short const choix,
						BITMAP * background,BITMAP* textoutput,unsigned short fich,unsigned short anc_choix)
{
unsigned short dummy3,dummy2;
unsigned	basex = 0,basecenter;

clear(textoutput);

#define side_choix(cond,init)	if (choix-(choix%20)cond)		\
 {																				\
  for (dummy3=0;dummy3<=19;dummy3++)								\
    {			                                                \
	  dummy2=init;										               \
	  if (dummy2+dummy3<dirt)											\
		{																		\
	    textprintf(textoutput,font,basex+1,2+dummy3*10,-5,"[%-8s]",to_display[dummy2+dummy3].str); \
	    textprintf(textoutput,font,basex,1+dummy3*10,-4,"[%-8s]",to_display[dummy2+dummy3].str);	 \
      }																												 \
	  else  																								          \
		 {																												 \
	     textprintf(textoutput,font,basex+1,2+10*dummy3,-2,"%s%s",faff(to_display[dummy2+dummy3].str),"            ");	\
        textprintf(textoutput,font,basex,1+10*dummy3,-3,"%s%s",faff(to_display[dummy2+dummy3].str),"            ");	\
       }																																			\
   }																																				\
  basex+=8*16;																																	\
 }


side_choix(>=20,choix-(choix%20)-20);

basecenter=basex;
for (dummy3=0;dummy3<=19;dummy3++)
    {			//{? choix - choix mod 20 + dummy 3 < dirt}
	dummy2=choix-(choix%20);
	if (dummy2+dummy3<dirt)
 	  { //dir
      textprintf(textoutput,font,basex+1,2+dummy3*10,-5,"[%-8s]",to_display[dummy2+dummy3].str);
	    if (choix % 20==dummy3)
		   textprintf(textoutput,font,basex,1+dummy3*10,-1,"[%-8s]",to_display[dummy2+dummy3].str);
	    else
		   textprintf(textoutput,font,basex,1+dummy3*10,-4,"[%-8s]",to_display[dummy2+dummy3].str);
	  }
	else  //file
	  {
	    textprintf(textoutput,font,basex+1,2+10*dummy3,-2,"%s%s",faff(to_display[dummy2+dummy3].str),"            ");
        if (choix % 20==dummy3)
		    textprintf(textoutput,font,basex,1+10*dummy3,-1,"%s%s",faff(to_display[dummy2+dummy3].str),"            ");
         else
		    textprintf(textoutput,font,basex,1+10*dummy3,-3,"%s%s",faff(to_display[dummy2+dummy3].str),"            ");
     }
    }
basex+=8*16;


side_choix(<dirt+fich-20,choix-(choix%20)+20);
side_choix(<dirt+fich-40,choix-(choix%20)+40);

{
 char diff=anc_choix-(anc_choix%20)-choix+(choix%20);
if (diff<0)
  { //a bit of scrolling ->
	unsigned	x;
	for (x=basecenter-16*8;x<basecenter;x+=16)
		{
		vsync();
      blit(background,screen,0,0,(vwidth-background->w)/2,(vheight-background->h)/2,
        background->w,background->h);
      masked_blit(textoutput,screen,x,0,(vwidth-background->w)/2,(vheight-background->h)/2,
        background->w,background->h);
		 }
	}
if (diff>0)
  { //a bit of scrolling <-
	unsigned	x;
	for (x=basecenter+16*8;x>basecenter;x-=16)
		{
		vsync();
      blit(background,screen,0,0,(vwidth-background->w)/2,(vheight-background->h)/2,
        background->w,background->h);
      masked_blit(textoutput,screen,x,0,(vwidth-background->w)/2,(vheight-background->h)/2,
        background->w,background->h);
		 }
	}
}

vsync();
blit(background,screen,0,0,(vwidth-background->w)/2,(vheight-background->h)/2,
	    background->w,background->h);
masked_blit(textoutput,screen,basecenter,0,(vwidth-background->w)/2,(vheight-background->h)/2,
	    background->w,background->h);

}

/*****************************************************************************

    Function:  select

    Description: handle keyboard in the file selector
    Parameters: lot of! heavily derived from pascal and C can't handle imbricated funcs!
    Return: nothing but *choix may change

*****************************************************************************/


void select(char *nom_dir,
				unsigned *choix,unsigned *dirt,char fichier [1600][14],
				unsigned * fich,char* attr,
				char *ext,BITMAP* textoutput,char* must_draw,TO_DISPLAY to_display[1600])
{
int t;
static char idx_col=0, temp_col=0;
while (!keypressed())
  {
	 pause();
	 vsync();
	 temp_col=!temp_col;
	 if (temp_col) // a bit of delay
      set_color(255,&cycle[idx_col++,idx_col&=0x1F]);
	 frame++;
  }
t=readkey();

switch ( t & 0xFF )
  {
	case 13:
   case 32 : {
		if (*choix<*dirt) //change dir
		  {
			 strcat(nom_dir,"/");
		    strcat(nom_dir,fichier[to_display[*choix].corr]);
          _fixpath(nom_dir,nom_dir);
		    strupr(nom_dir);

		 {
		  unsigned dummy;
		  for (dummy=0;dummy<1600;dummy++)
		      strcpy(to_display[dummy].str,"");
       }

		 Dir(dirt,fich,nom_dir,attr,fichier,must_draw,to_display);
		 clear(textoutput);

		 *choix=0;
		}
		else //file
		 {
		   strcpy(tmp_buf,nom_dir);
		   if (strlen(nom_dir)!=3)
		     strcat(tmp_buf,"/");
		   strcat(tmp_buf,fichier[to_display[*choix].corr]);
		   strupr(tmp_buf);
		   *ext=1;
		 }
      return;
		}
	case 27 : *ext=1;
		strcpy(tmp_buf,"NO FILE");
		return;
	case 'A' ... 'Z':
   case 'a' ... 'z':
		strcpy(nom_dir," :/");
		nom_dir[0]=(char)t;
		 {
		  unsigned dummy;
		  for (dummy=0;dummy<1600;dummy++)
		      strcpy(to_display[dummy].str,"");;
       }


       Dir(dirt,fich,nom_dir,attr,fichier,must_draw,to_display);

		 clear(textoutput);
		*choix=0;
		return;
   }
switch (t)
  {
	case 0x5000:
		     if (*choix<*fich+*dirt-1)
 		       (*choix)++;
		     return;
	case 0x4800:
		     if (*choix>0)
		       (*choix)--;
		     return;
   case 0x4D00:
		     if ((*choix)+21<=(*fich)+(*dirt))
		      {
		       *choix+=20;
		       return;
		      }
		     else
            {
			    *choix=(*fich)+(*dirt)-1;
			    return;
            };
   case 0x4B00:
		     if (*choix>20)
		       *choix-=20;
		     else *choix=0;
		     return;
   case 0x4700: *choix=0;
		         return;
   case 0x4F00: *choix=*fich+*dirt-1;
		         return;
    } //1st case
}


void Dir(unsigned *dirt,unsigned *fich,char *nom_dir/*,char direct[100][14]*/,char* const attr,/*char fi[1500][14],*/char fichier [1600][14],char* must_draw,TO_DISPLAY to_display[1600])
{
  char direct[100][14];
  char fi[1500][14];
  struct ffblk DirBuf;
  unsigned i,dummy;
  char tmp_dir[80];

  *dirt=*fich=0;
  *must_draw=1;

  strcpy(tmp_dir,nom_dir);

  strcat(tmp_dir,"/*.*");
  if (findfirst( tmp_dir, &DirBuf , FA_DIREC )==0)    // Look for the first entry
    do
     {
     if ((( DirBuf.ff_attrib & 0x10) != 0) && (strcmp(DirBuf.ff_name,".")!=0))
		    {
					strcpy(direct[(*dirt)++],strupr(DirBuf.ff_name));
					direct[(*dirt)-1][13]=0;
          }
     }
    while (findnext(&DirBuf)==0);    // until there's no more
   strcpy(tmp_dir,nom_dir);
   strcat(tmp_dir,"/");
   strcat(tmp_dir,attr);

   if (findfirst ( tmp_dir , &DirBuf, FA_RDONLY|FA_ARCH)==0)
    do
      {
        if (( DirBuf.ff_attrib & 0x10) == 0)
			 {
	  	      strcpy(fi[(*fich)++],strupr(DirBuf.ff_name));
				fi[(*fich)-1][13]=0;
          }
      }
    while (findnext(&DirBuf)==0);

    i=0;
    if (*dirt>0)
      for (dummy=0;dummy<*dirt;dummy++)
		  {
	 	    strcpy(fichier[i],direct[dummy]);
			 to_display[i].corr=i;
			 strcpy(to_display[i++].str,direct[dummy]);
        }
    if (*fich>0)
      for (dummy=0;dummy<*fich;dummy++)
        {
 	       strcpy(fichier[i],fi[dummy]);
			 to_display[i].corr=i;
			 strcpy(to_display[i++].str,fi[dummy]);
		  }
//    qsort(fichier,*dirt,14,strcmp);
//    qsort(&fichier[*dirt],*fich,14,strcmp);
    qsort(to_display,*dirt,sizeof(TO_DISPLAY),strcmp);
    qsort(&to_display[*dirt],*fich,sizeof(TO_DISPLAY),strcmp);

  }

/*****************************************************************************

    Function:  select_rom

    Description: ask the user for a rom
    Parameters: char* attr, the file mask
    Return:a pointer to selected_rom containing "NO FILE" is ESC was pushed
	                  else the full name selected

*****************************************************************************/


char* select_rom(char *attr)
 {
  char fichier[1600][14];
  TO_DISPLAY to_display[1600];
  unsigned fich,dirt;
  char nom_dir[80];
  unsigned dummy,choix,anc_choix;
  char ext,must_draw=1;
  PALETTE pal,old_pal;
  BITMAP* background;
  BITMAP* textoutput;
/******************************************************************/
tmp_buf=(char*)xmalloc(100);

sprintf(tmp_buf,"%sFS_TST.TGA",short_exe_name);

background = load_tga(tmp_buf,pal);

_fixpath(attr,tmp_buf);
dummy=strlen(tmp_buf);
while (tmp_buf[dummy]!='/')
	dummy--;
strncpy(nom_dir,tmp_buf,dummy);
nom_dir[dummy]=0;
strupr(nom_dir);
for (ext=0;ext<16;ext++ )
   {
	 //cycle[ext].r=(63+ext*(255-63)/15)/4;
	 //cycle[ext].g=(13+ext*(255-13)/15)/4;
	 //cycle[ext].b=(227+ext*(255-227)/15)/4;
	 cycle[31-ext].r=cycle[ext].r=(63+(255-63)*(sin((PI*ext)/16))*(sin((PI*ext)/16)))/4;
	 cycle[31-ext].g=cycle[ext].g=(13+(255-13)*(sin((PI*ext)/16))*(sin((PI*ext)/16)))/4;
    cycle[31-ext].b=cycle[ext].b=(227+(255-227)*(sin((PI*ext)/16))*(sin((PI*ext)/16)))/4;

   }


ext=0;


text_mode(-1);
get_palette(old_pal);
set_palette(pal);
clear(screen);

//blit(background,screen,0,0,(vwidth-background->w)/2,(vheight-background->h)/2,
//      background->w,background->h);
(*fade_in_proc[rand()%nb_fadein])(background,(vwidth-background->w)/2,(vheight-background->h)/2,
					 background->w,background->h);

 {
  unsigned dummy;
  for (dummy=0;dummy<1600;dummy++)
      strcpy(to_display[dummy].str,"");;
 }

Dir(&dirt,&fich,nom_dir,attr,fichier,&must_draw,to_display);
textoutput = create_bitmap(512,200);
//enough for name of 20 car. without space between 2 rows

clear(textoutput);

anc_choix=choix=0;

do
  {
if ((anc_choix!=choix) || must_draw)
 affichechoix(to_display,dirt,choix,background,textoutput,fich,anc_choix);
anc_choix=choix;
must_draw=0;
select(nom_dir,&choix,&dirt,fichier,&fich,attr,&ext,textoutput,&must_draw,to_display);
  }
while (!ext);

  //special_fadeout1((vwidth-background->w)/2,(vheight-background->h)/2,
//					 background->w,background->h);
  (*fade_out_proc[ext=rand()%nb_fadeout])((vwidth-background->w)/2,(vheight-background->h)/2,
					 background->w,background->h);
  set_palette(old_pal);
  destroy_bitmap(background);
  destroy_bitmap(textoutput);
  strcpy(selected_rom,tmp_buf);
  xfree(tmp_buf);
  return selected_rom;
  }
