/*
	Portable PC-Engine Emulator
	1998 by BERO bero@geocities.co.jp

    Modified 1998 by hmmx hmmx@geocities.co.jp
    Modified 1999 by Zeograd (Olivier Jolly) zeograd@caramail.com
*/

#include	"pce.h"

const char* joy_str[]={"UP","DOWN","LEFT","RIGHT","I","II","SELECT","START","AUTOI","AUTOII"};


byte RAM[0x8000];
// mem where variables are stocked (well, RAM... )

//byte PopRAM[0x8000];
//byte PopRAM[0x10000];
byte *PopRAM;
// Now dynamicaly allocated
// ( size of popRAMsize bytes )
// If someone could explain me why we need it
// the version I have works well without this trick

const PopRAMsize = 0x8000;
// I don't really know if it must be 0x8000 or 0x10000

#define	ZW	64
//byte ZBuf[ZW*256];
byte *Page[8],*ROMMap[256];
//BOOL IsROM[8];
byte *VRAM,*ROM,*vchange,*vchanges,*PCM,*WRAM,*DMYROM,*IOAREA;
// WRAM = backup RAM (~ the one on CD ROM drive)

short SPRAM[64*4];
// SPRAM = sprite RAM

byte SPM[WIDTH*HEIGHT];
unsigned long *VRAM2,*VRAMS;

int ROM_size;
// obvious, no ?
// actually, the number of block of 0x2000 bytes in the rom

extern int vmode;
// What is the favorite video mode to use
// 0 -> 256*240
// 1 -> 256*256
// 2 -> 320*200

int smode;
// what sound card type should we use? (0 means the silent one,
// my favorite : the fastest!!! ; and -1 means AUTODETECT;
// later will avoid autodetection if wanted)

char silent=1;
// a bit different from the previous one, even if asked to
// use a card, we could not be able to make sound...

unsigned char nb_joy = 1;
// number of input to poll

int Country;
// Is this^ initialised anywhere ?
// You may try to play with if some games don't want to start
// it could be useful on some cases

int IPeriod;
// Number of cycle between two interruption calls

extern int BaseClock, UPeriod;
static int TimerCount,CycleOld;
int TimerPeriod;
int scanlines_per_frame	 = 263;
int scanline;

#define	MinLine	io.minline
#define	MaxLine	io.maxline
//int MinLine = 0,MaxLine = 255;
#define	MAXDISP	227

byte BGONSwitch	= 1;
// do we have to draw background ?

byte SPONSwitch	= 1;
// Do we have to draw sprites ?

char *cart_name;
// Name of the file containing the ROM

char short_cart_name[80];
// Just the filename without the extension (with a dot)
// you just have to add your own extension...

char short_exe_name[80];
// Used to function whatever the launching directory
// Help working under WIN9X without troubles
// Actually, the path of the EXE

char sav_path[80];
// The place where to keep saved games
// currently a subdir a the EXE path named 'SAV'

byte cart_reload = 0;
// Once the game ended, do we need to load another rom
// i.e. do we escape game by pressing F12 or do we called the file selector

char effectively_played = 0;
// Well, the name is enough I think...

byte populus = 0;
// no more hasardous detection
// thanks to the CRC detection
// now, used to know whether the save file
// must contain extra info

int scroll = 0;

signed char snd_vol[6][32];
// cooked volume for each channel

#ifndef	ALLEGRO
#error You should implement fixed type by yourself
#else
fixed snd_inc[6],snd_pos[6]={0,0,0,0,0,0};
// how mush do we have to advance the index of each voice
// limit the use of division in sound mixing and position
#endif

unsigned freq_int=11025;
// frequency of interrupt to be used to make sound

volatile char key_delay=0;
// delay to avoid to many key strokes

volatile char can_blit=1;
// used to sync screen to 60 image/sec.

volatile unsigned message_delay=0;
// if different of zero, we must display the message pointed by pmessage

byte Pal[512];

IO io;
// variable containing the different port and others...

//extern char	*pCartName;

//extern char snd_bSound;

int frame = 0;
// number of frame displayed

unsigned timer_60 = 0;
// how many times do the interrupt have been called

unsigned char joy_mapping[5][10];

/*static*/ int UPeriod = 0;
// Number of frame to skip

static int BaseClock;

#define	VRR	2
enum _VDC_REG {
	MAWR,MARR,VWR,vdc3,vdc4,CR,RCR,BXR,
	BYR,MWR,HSR,HDR,VPR,VDW,VCR,DCR,
	SOUR,DISTR,LENR,SATB};
#define	NODATA	0xff
#define	ENABLE	1
#define	DISABLE	0

#define	VDC_CR	0x01
#define	VDC_OR	0x02
#define	VDC_RR	0x04
#define	VDC_DS	0x08
#define	VDC_DV	0x10
#define	VDC_VD	0x20
#define	VDC_BSY	0x40
#define	VDC_SpHit	VDC_CR
#define	VDC_Over	VDC_OR
#define	VDC_RasHit	VDC_RR
#define	VDC_InVBlank	VDC_VD
#define	VDC_DMAfinish	VDC_DV
#define	VDC_SATBfinish	VDC_DS

#define	SpHitON		(io.VDC[CR].W&0x01)
#define	OverON		(io.VDC[CR].W&0x02)
#define	RasHitON	(io.VDC[CR].W&0x04)
#define	VBlankON	(io.VDC[CR].W&0x08)
#define	SpriteON	(io.VDC[CR].W&0x40)
#define	ScreenON	(io.VDC[CR].W&0x80)

#define	SATBIntON	(io.VDC[DCR].W&0x01)
#define	DMAIntON	(io.VDC[DCR].W&0x02)

#define	IRQ2	1
#define	IRQ1	2
#define	TIRQ	4

//#define ScrollX	io.scroll_x
//#define ScrollY io.scroll_y
#define	ScrollX	io.VDC[BXR].W
#define	ScrollY	io.VDC[BYR].W
int	ScrollYDiff;
int	oldScrollX;
int	oldScrollY;
int	oldScrollYDiff;

typedef	struct {
	short y,x,no,atr;
} SPR;
// Sprite structure
// y,x = pos
// no = number of the sprite (0..63  for core graphx,
//                            0..127 for super graphx (to be checked) )
// atr = attributes
// bit 0-4 : number of palette to be used
// bit 7 : background sprite
//          0 -> must be drawn behind tile patterns
//          1 -> must be drawn in front of patterns
//          (Or maybe it's the contrary ;)
// bit 8 : width
//          0 -> 16 pixels
//          1 -> 32 pixels
// bit 11 : horizontal flip
//          0 -> normal shape
//          1 -> must be draw horizontaly flipped
// bit 13-12 : heigth
//          00 -> 16 pixels
//          01 -> 32 pixels
//          10 -> 48 pixels
//          11 -> 64 pixels
// bit 15 : vertical flip
//          0 -> normal shape
//          1 -> must be drawn verticaly flipped
int CheckSprites(void);
int JoySticks(void);

void  IO_write(word A,byte V);
byte  IO_read(word A);
void RefreshLine(int Y1,int Y2);
void RefreshSprite(int Y1,int Y2,BYTE bg);
void RefreshScreen(void);
unsigned long CRC_file(char*);

void interrupt_60hz()
  {
/*#ifndef FINAL_RELEASE
   for (can_blit=0;can_blit<6;can_blit++)
      write_psg(can_blit);
#endif*/
   can_blit=1;
   if (key_delay)
     key_delay--;
   if (message_delay)
     message_delay--;
   timer_60++;
   return;
   };
END_OF_FUNCTION(interrupt_60hz);


#ifndef	FINAL_RELEASE

unsigned char tmp_wave [0x100000];
unsigned tmp_index=0;
#define	BLASTER	0x220


void interrupt_snd()
  {
   signed char t,out=0;
//   ScreenVisualBell();
//   textout(screen,font,"X",0,0,1);
   for (t=0;t<6;t++)
     {
      snd_pos[t]+=snd_inc[t];
//      if (snd_pos[t]>itofix(31))
//        snd_pos[t]-=itofix(31);
      snd_pos[t]&=31*65535+65536;
      //snd_pos[t]&=31<<16+0xFFFF;
      if (io.PSG[t][4]&0x80)
       {
	if (!(io.PSG[t][4]&0x40))
	  out+=snd_vol[t][io.wave[t][fixtoi(snd_pos[t])]];//*io.PSG[t][4]&15;
//            out+=io.wave[t][fixtoi(snd_pos[t])]*io.PSG[t][4]&15;
	else
	  out+=snd_vol[t][io.wave[t][0]];
//            out+=io.wave[t][0]*io.PSG[t][4]&15;
       }
     };
//  while ((inportb(BLASTER+0x0C) & 0x80) != 0);
//   outportb(BLASTER+0x0C, 0x10);
  // while ((inportb(BLASTER+0x0C) & 0x80) != 0);
   //outportb(BLASTER+0x0C, out);

   if (tmp_index<0x100000)
     tmp_wave[tmp_index++]=out;
   }
END_OF_FUNCTION(interrupt_snd);

#endif

void bank_set(byte P,byte V)
{
#ifndef FINAL_RELEASE
	if (V>=ROM_size	&& V<0xF7) {
	//	printf("ignore bank set %x:%02x",P,V);
	//	TrashMachine();
	//	exit(-1);
	}
#endif
	if (ROMMap[V]==IOAREA)
		Page[P]=IOAREA;
	else
		Page[P]=ROMMap[V]-P*0x2000;
//	IsROM[P] = (V < 0xF7);
}

byte _Rd6502(word A)
{
	if (Page[A>>13]!=IOAREA) return	Page[A>>13][A];
	else return IO_read(A);
}

void _Wr6502(word A,byte V)
{
	if (Page[A>>13]!=IOAREA)
	{
//void DebugDumpFp(int nMemDump, BOOL bDispStack);
//		if (A==0x2003)
//		{
//			TRACE("val=%02X\n",V);
//			DebugDumpFp(4, TRUE);
//		}
//		if (IsROM[A>>13])
//			TRACE0("Writed to ROM\n");
//		else
			Page[A>>13][A]=V;
	}
	else IO_write(A,V);
}

/* write */
	M6502 M;

void  IO_write(word A,byte V)
{
	//printf("w%04x,%02x ",A&0x3FFF,V);
  switch(A&0x1C00) {
  case 0x0000:	/* VDC */
	switch(A&3){
	case 0:	io.vdc_reg = V&31; return;
	case 1:	return;
	case 2:
		//printf("vdc_l%d,%02x ",io.vdc_reg,V);
		switch(io.vdc_reg){
		case VWR:
			/*VRAM[io.VDC[MAWR].W*2] = V;*/	io.vdc_ratch = V;
			//io.VDC_ratch[VWR] = V;
/*			if (0x1000 <= io.VDC[MAWR].W && io.VDC[MAWR].W < 0x1008)
			{
				TRACE("L: PC = %X, ", M.PC.W);
				for (int i = -10; i < 4; i++)
					TRACE("%02X ", Page[(M.PC.W+i)>>13][M.PC.W+i]);
				TRACE("\nL: V[%X] = %X\n", io.VDC[MAWR].W, V);
			}
*/			return;
		case HDR:
			io.screen_w = (V+1)*8;
			//printf("screen:%dx%d %d\n",io.screen_w,256,V);
			//TRACE("HDRl: %X\n", V);
			break;
		case MWR:
			{static	byte bgw[]={32,64,128,128};
			io.bg_h=(V&0x40)?64:32;
			io.bg_w=bgw[(V>>4)&3];}
			//TRACE("bg:%dx%d, V:%X\n",io.bg_w,io.bg_h, V);
			//TRACE("MWRl: %02X\n", V);
			break;
		case BYR:
			if (!scroll) {
				oldScrollX = ScrollX;
				oldScrollY = ScrollY;
				oldScrollYDiff = ScrollYDiff;
			}
			io.VDC[BYR].B.l	= V;
			scroll=1;
//			io.vdc_iswrite_h = 0;
//			if (scanline <= MaxLine)
//			{
				//TRACE("BYRl = %d, scanline = %d, h = %d\n", io.VDC[BYR].W, scanline, io.screen_h);
			//if (RasHitON)
				ScrollYDiff=scanline-1;
//			}
//			else
//				ScrollYDiff=0;
			//TRACE("BYRl = %d, scanline = %d, h = %d\n", io.VDC[BYR].W, scanline, io.screen_h);
			return;
		case BXR:
			if (!scroll) {
				oldScrollX = ScrollX;
				oldScrollY = ScrollY;
				oldScrollYDiff = ScrollYDiff;
			}
			io.VDC[BXR].B.l	= V;
			scroll=1;
			return;
			
//#define PRINT_VDC_L(REG)	case REG: TRACE(#REG "l: %X\n",V);break;
//			PRINT_VDC_L(CR);
/*			PRINT_VDC_L(HSR);
			PRINT_VDC_L(VPR);
			PRINT_VDC_L(VDW);
			PRINT_VDC_L(VCR);
			PRINT_VDC_L(SOUR);
			PRINT_VDC_L(DISTR);
			PRINT_VDC_L(DCR);*/
			
		}
		io.VDC[io.vdc_reg].B.l = V; //io.VDC_ratch[io.vdc_reg] = V;
//		if (io.vdc_reg != CR)
//			TRACE("vdc_l: %02X,%02X\n", io.vdc_reg, V);
#ifndef	FINAL_RELEASE
		if (io.vdc_reg>19) {
			fprintf(stderr,"ignore write lo vdc%d,%02x\n",io.vdc_reg,V);
		}
#endif
		return;
	case 3:
		//printf("vdc_h%d,%02x ",io.vdc_reg,V);
		switch(io.vdc_reg){
		case VWR:
			//printf("v%04x\n",io.VDC[MAWR].W);
			VRAM[io.VDC[MAWR].W*2]=io.vdc_ratch;
			VRAM[io.VDC[MAWR].W*2+1]=V;
/*			if (0x1000<=io.VDC[MAWR].W&&io.VDC[MAWR].W<0x1008)
			{
				TRACE("adr=%04X,val=%02X%02X\n", io.VDC[MAWR].W, V, io.vdc_ratch);
				//DebugDumpFp(4, TRUE);
			}
*/
/*			if (0x1000 <= io.VDC[MAWR].W && io.VDC[MAWR].W < 0x1100)
			{
				TRACE("PC = %X, ", M.PC.W);
				for (int i = -10; i < 4; i++)
					TRACE("%02X ", Page[(M.PC.W+i)>>13][M.PC.W+i]);
				TRACE("\nPage = %d", (Page[(M.PC.W)>>13] - ROM)/0x2000);
				TRACE("\nV[%X] = %02X%02X\n", io.VDC[MAWR].W, VRAM[io.VDC[MAWR].W*2+1], VRAM[io.VDC[MAWR].W*2]);
				TRACE("Page: ");
				for (i = 0; i < 8; i++)
					TRACE("%02X ", M.MPR[i]);
				TRACE("\nZero: ");
				for (i = 0; i < 32; i++)
					TRACE("%02X ", RAM[i]);
				TRACE("\n");
			}
*/			vchange[io.VDC[MAWR].W/16]=1;
			vchanges[io.VDC[MAWR].W/64]=1;
			io.VDC[MAWR].W+=io.vdc_inc;
			io.vdc_ratch=0;
			return;
		case VDW:
			//io.VDC[VDW].B.l = io.VDC_ratch[VDW];
			io.VDC[VDW].B.h	= V;
			io.screen_h = (io.VDC[VDW].W&511)+1;
			MaxLine	= io.screen_h-1;
			//TRACE("VDWh: %X\n", io.VDC[VDW].W);
			return;
		case LENR:
			//io.VDC[LENR].B.l = io.VDC_ratch[LENR];
			io.VDC[LENR].B.h = V;
			//TRACE("DMA:%04x %04x %04x\n",io.VDC[DISTR].W,io.VDC[SOUR].W,io.VDC[LENR].W);
			/* VRAM to VRAM DMA */
			memcpy(VRAM+io.VDC[DISTR].W*2,VRAM+io.VDC[SOUR].W*2,
				(io.VDC[LENR].W+1)*2);
			memset(vchange+io.VDC[DISTR].W/16,1,(io.VDC[LENR].W+1)/16);
			memset(vchange+io.VDC[DISTR].W/64,1,(io.VDC[LENR].W+1)/64);
			io.VDC[DISTR].W	+= io.VDC[LENR].W+1;
			io.VDC[SOUR].W += io.VDC[LENR].W+1;
			io.vdc_status|=VDC_DMAfinish;
			return;
		case CR	:
			{static	byte incsize[]={1,32,64,128};
			io.vdc_inc = incsize[(V>>3)&3];
			//TRACE("CRh: %02X\n", V);
			}
			break;
		case HDR:
			//io.screen_w = (io.VDC_ratch[HDR]+1)*8;
			//TRACE0("HDRh\n");
			break;
		case BYR:
			if (!scroll) {
				oldScrollX = ScrollX;
				oldScrollY = ScrollY;
				oldScrollYDiff = ScrollYDiff;
			}
			io.VDC[BYR].B.h	= V&1;
			scroll=1;
//			io.vdc_iswrite_h = 1;
//			if (scanline <= MaxLine)
//			{
				//TRACE("BYRh = %d, scanline = %d, h = %d\n", io.VDC[BYR].W, scanline, io.screen_h);
			//if (RasHitON)
			{
				ScrollYDiff=scanline-1;
				//TRACE("BYRh = %d, scanline = %d, h = %d\n", io.VDC[BYR].W, scanline, io.screen_h);
				//DebugDumpFp(4, TRUE);
			}
//			}
//			else
//				ScrollYDiff=0;
			//ScrollY = 51-35;
			return;
		case SATB:
			io.VDC[SATB].B.h = V;
			//TRACE("SATB=%X,scanline=%d\n", io.VDC[SATB].W, scanline);
			//memcpy(SPRAM,VRAM+io.VDC[SATB].W*2,64*8);
			io.vdc_satb=1;
			io.vdc_status&=~VDC_SATBfinish;
			return;
		case BXR:
			if (!scroll) {
				oldScrollX = ScrollX;
				oldScrollY = ScrollY;
				oldScrollYDiff = ScrollYDiff;
			}
			io.VDC[BXR].B.h	= V & 3;
			scroll=1;
//			ScrollX = io.VDC[BXR].W;
//			TRACE("BXRh = %d, scanline = %d\n", io.VDC[BXR].W, scanline);
//			io.VDC[BXR].W = 256;
			return;
			
/*#define PRINT_VDC_H(REG)	case REG: TRACE(#REG "h: %X\n",V);break;
			PRINT_VDC_H(HSR);
			PRINT_VDC_H(HDR);
			PRINT_VDC_H(VPR);
			PRINT_VDC_H(VCR);
			PRINT_VDC_H(SOUR);
			PRINT_VDC_H(DISTR);
			PRINT_VDC_H(DCR);*/
		//case RCR: TRACE("RCR: %02X%02X\n", V, io.VDC[io.vdc_reg].B.l);break;

		}
		//io.VDC[io.vdc_reg].B.l = io.VDC_ratch[io.vdc_reg];
		io.VDC[io.vdc_reg].B.h = V;
//		if (io.vdc_reg != CR)
//			TRACE("vdc_h: %02X,%02X\n", io.vdc_reg, V);
#ifndef	FINAL_RELEASE
		if (io.vdc_reg>19) {
			fprintf(stderr,"ignore write hi vdc%d,%02x\n",io.vdc_reg,V);
		}
#endif
		return;
	}
	break;

  case 0x0400:	/* VCE */
	switch(A&7) {
	case 0:	/*io.vce_reg.W = 0; io.vce_ratch=0;*/ /*??*/
		/*TRACE("VCE 0, V=%X\n", V);*/ return;
	case 2:	io.vce_reg.B.l = V; return;
	case 3:	io.vce_reg.B.h = V&1; return;
	case 4:	io.VCE[io.vce_reg.W].B.l= V;
		{
		 byte c; int i,n;
		 n = io.vce_reg.W;
		 c = io.VCE[n].W>>1;
		 if (n==0) {
			for(i=0;i<256;i+=16) Pal[i]=c;
		 }else if (n&15) Pal[n]	= c;
		}


		return;
	case 5:
		/*io.VCE[io.vce_reg.W].B.l = io.vce_ratch;*/
//	DebugDumpFp(4, TRUE);
		io.VCE[io.vce_reg.W].B.h = V;
		{
		 byte c; int i,n;
		 n = io.vce_reg.W;
		 c = io.VCE[n].W>>1;
		if (n==0) {
			for(i=0;i<256;i+=16) Pal[i]=c;
		}else if (n&15)	Pal[n] = c;
		}
		io.vce_reg.W=(io.vce_reg.W+1)&0x1FF;
		return;
	//case 6: /* ?? */ return;
	case 1:	/*TRACE("VCE 1, V=%X\n", V);*/ return;
	case 6:	/*TRACE("VCE 6, V=%X\n", V);*/ return;
	case 7:	/*TRACE("VCE 7, V=%X\n", V);*/ return;
	}
	break;

#ifdef	SOUND

  case 0x0800:	/* PSG */
/*	if (/*snd_bSound && io.psg_ch < 6)
	{
//		if (io.psg_ch==0)
//			TRACE("PSG %d,%02X\n", A&15, V);

                //int i; // a virer
		if ((A&15) <= 1)
		{
			int	i;
			for (i = 0; i < 6; i++)
				write_psg(i);
		}
		else
			write_psg(io.psg_ch);
                //for (i=0; i<6 ; fprintf(stderr,"FREQ n%d = %d\nVOL = %d\n",i,io.PSG[i][2]+io.PSG[i][3]<<8,io.PSG[i][4]&31),i++);
	}                   */

#define	BASE_FREQ 3700000
#define	ajust_vol {		     \
		  char j;	     \
		  fixed	tmp=itofix((io.PSG[io.psg_ch][4]&15)* \
		     ((io.PSG[io.psg_ch][5]&15)+(io.PSG[io.psg_ch][5]>>4))*	\
		     ((io.psg_volume&15)+(io.psg_volume>>4)))/(6*32*32),tmp2=0;  \
		  for (j=0;j<32;j++,tmp2+=tmp) \
		     snd_vol[io.psg_ch][j]=/*(signed char)(j-16)/*/fixtoi(tmp2);\
		}


  	switch(A&15){
	case 0:	io.psg_ch = V&7; return;
	case 1:	io.psg_volume =	V; return;
	case 2:	io.PSG[io.psg_ch][2] = V;
		if ((!V) && (!io.PSG[io.psg_ch][3]))
		  snd_inc[io.psg_ch]=0;
		else
		  snd_inc[io.psg_ch]=itofix(/*1118608*/BASE_FREQ/(io.PSG[io.psg_ch][2]+io.PSG[io.psg_ch][3]*256))/freq_int;
//                  snd_inc[io.psg_ch]=itofix(io.PSG[io.psg_ch][2]+io.PSG[io.psg_ch][3]*256)/freq_int;
	     break;
	case 3:	io.PSG[io.psg_ch][3] = V&15;
		if ((!(V&15)) && (!io.PSG[io.psg_ch][2]))
		  snd_inc[io.psg_ch]=0;
		else
		  snd_inc[io.psg_ch]=itofix(/*1118608*/BASE_FREQ/(io.PSG[io.psg_ch][2]+io.PSG[io.psg_ch][3]*256))/freq_int;
//                  snd_inc[io.psg_ch]=itofix(io.PSG[io.psg_ch][2]+io.PSG[io.psg_ch][3]*256)/freq_int;

//                snd_inc[io.psg_ch]=itofix(io.PSG[io.psg_ch][2]+io.PSG[io.psg_ch][3]<<8)/freq_int;
	     break;
	case 4:	io.PSG[io.psg_ch][4] = V;
		ajust_vol;
	     break;
	case 5:	io.PSG[io.psg_ch][5] = V;
		ajust_vol;
	     break;
	case 6:	if (io.PSG[io.psg_ch][4]&0x40){
				io.wave[io.psg_ch][0]=V&31;
			}else {
				//io.wave[io.psg_ch][io.wavofs[io.psg_ch]]=V&31;
				//io.wavofs[io.psg_ch]=(io.wavofs[io.psg_ch]+1)&31;
				io.wave[io.psg_ch][fixtoi(snd_pos[io.psg_ch])]=V&31;
				snd_pos[io.psg_ch]=itofix((fixtoi(snd_pos[io.psg_ch])+1)&31);

			} break;
	case 7:	/*if (io.psg_ch!=5)*/
              io.PSG[io.psg_ch][7] = V;
            /*else io.PSG[5][7] = 135;*/
            break;
	case 8:	io.psg_lfo_freq	= V; break;
	case 9:	io.psg_lfo_ctrl	= V; break;
#ifndef FINAL_RELEASE
	default: fprintf(stderr,"ignored PSG write\n");
#endif
    }
    return;
#endif

  case 0x0c00:	/* timer */
	//TRACE("Timer Access: A=%X,V=%X\n", A, V);
	switch(A&1){
	case 0:	io.timer_reload	= V&127; return;
	case 1:	
		V&=1;
		if (V && !io.timer_start)
			io.timer_counter = io.timer_reload;
		io.timer_start = V;
		return;
	}
	break;

  case 0x1000:	/* joypad */
//	  TRACE("V=%02X\n", V);
		io.joy_select =	V&1;
      //io.joy_select = V;
		if (V&2) io.joy_counter	= 0;
		return;

  case 0x1400:	/* IRQ */
	switch(A&15){
	case 2:	io.irq_mask = V;/*TRACE("irq_mask = %02X\n", V);*/ return;
	case 3:	io.irq_status= (io.irq_status&~TIRQ)|(V&0xF8); return;
	}
	break;

  case 0x1800:	/* CD-ROM extention */
	switch(A&15){
	case 7:	io.backup = ENABLE; return;
/*	case 8: io.adpcm_ptr.B.l = V; return;
	case 9: io.adpcm_ptr.B.h = V; return;
	case 0xa: PCM[io.adpcm_wptr++] = V; return;
	case 0xd:
		if (V&4) io.adpcm_wptr = io.adpcm_ptr.W;
		else { io.adpcm_rptr = io.adpcm_ptr.W; io.adpcm_firstread = TRUE; }
		return;
*/	}
	break;
  }
#ifndef	FINAL_RELEASE
	fprintf(stderr,"ignore I/O write %04x,%02x\n",A,V);
#endif
//	DebugDumpTrace(4, TRUE);
}

/* read */
byte IO_read(word A)
{
	byte ret;
	//printf("r%04x ",A&0x3FFF);
  switch(A&0x1C00){
  case 0x0000: /* VDC */
  	switch(A&3){
	case 0:
		ret = io.vdc_status;
		io.vdc_status=0;//&=VDC_InVBlank;//&=~VDC_BSY;
		return ret;
	case 1:
		return 0;
	case 2:
		if (io.vdc_reg==VRR)
			return VRAM[io.VDC[MARR].W*2];
		else return io.VDC[io.vdc_reg].B.l;
	case 3:
		if (io.vdc_reg==VRR) {
			ret = VRAM[io.VDC[MARR].W*2+1];
			io.VDC[MARR].W+=io.vdc_inc;
//			TRACE0("VRAM read\n");
			return ret;
		} else return io.VDC[io.vdc_reg].B.h;
	}
	break;

  case 0x0400:/* VCE */
  	switch(A&7){
	case 4:	return io.VCE[io.vce_reg.W].B.l;
	case 5:	return io.VCE[io.vce_reg.W++].B.h;
	}
	break;
#ifdef	SOUND
  case 0x0800:	/* PSG */
	switch(A&15){
	case 0:	return io.psg_ch;
	case 1:	return io.psg_volume;
	case 2:	return io.PSG[io.psg_ch][2];
	case 3:	return io.PSG[io.psg_ch][3];
	case 4:	return io.PSG[io.psg_ch][4];
	case 5:	return io.PSG[io.psg_ch][5];
	case 6:
		{
			//int	ofs=io.wavofs[io.psg_ch];
			//io.wavofs[io.psg_ch]=(io.wavofs[io.psg_ch]+1)&31;
			//return io.wave[io.psg_ch][ofs];
			int ofs=fixtoi(snd_pos[io.psg_ch]);
			snd_pos[io.psg_ch]=itofix((fixtoi(snd_pos[io.psg_ch])+1)&31);
			return io.wave[io.psg_ch][ofs];

		}
	case 7:	return io.PSG[io.psg_ch][7];
	case 8:	return io.psg_lfo_freq;
	case 9:	return io.psg_lfo_ctrl;
	default: return	NODATA;
	}
	break;
#endif
  case 0x0c00:	/* timer */
	return io.timer_counter;

  case 0x1000:	/* joypad */
//	  TRACE("js=%d\n", io.joy_counter);
		ret = io.JOY[io.joy_counter]^0xff;
		if (io.joy_select&1) ret>>=4;
		else { ret&=15;	io.joy_counter=(io.joy_counter+1)%5; }
		return ret|Country; /* country 0:JPN 1<<6=US */

  case 0x1400:	/* IRQ */
	switch(A&15){
	case 2:	return io.irq_mask;
	case 3:	ret = io.irq_status;io.irq_status=0;return ret;
	}
	break;

  case 0x1800:	/* CD-ROM extention */
	switch(A&15){
	case 3:	return io.backup = DISABLE;
//	case 0xa: 
//		if (!io.adpcm_firstread) return PCM[io.adpcm_rptr++];
//		else {io.adpcm_firstread=FALSE; return NODATA;}
	}
	break;
  }
#ifndef	FINAL_RELEASE
	fprintf(stderr,"ignore I/O read %04x\n",A);
#endif
//	DebugDumpFp(4, TRUE);
	return NODATA;
}

byte Loop6502(M6502 *R)
{
	static int UCount = 0;
//	static int ACount = 0;
	static int prevline;
	int dispmin, dispmax;
	int ret;
	//printf("PC:%04x ",R->PC.W);

	dispmin	= (MaxLine-MinLine>MAXDISP ? MinLine+((MaxLine-MinLine-MAXDISP+1)>>1) :	MinLine);
	dispmax	= (MaxLine-MinLine>MAXDISP ? MaxLine-((MaxLine-MinLine-MAXDISP+1)>>1) :	MaxLine);

	scanline=(scanline+1)%scanlines_per_frame;
	//printf("scan %d\n",scanline);
	ret = INT_NONE;
	io.vdc_status&=~VDC_RasHit;
	if (scanline>MaxLine)
		io.vdc_status|=VDC_InVBlank;
//	if (scanline==MinLine+scanlines_per_frame-1)
//	else 
	if (scanline==MinLine) {
		io.vdc_status&=~VDC_InVBlank;
		prevline=dispmin;
		ScrollYDiff = 0;
		oldScrollYDiff = 0;
//		if (io.vdc_iswrite_h)
//		{
//			io.vdc_iswrite_h = 0;
//			ScrollY = io.VDC[BYR].W;
//		}
//		TRACE("\nFirstLine\n");
	}else
	if (scanline==MaxLine) {
		if (CheckSprites()) io.vdc_status|=VDC_SpHit;
		else io.vdc_status&=~VDC_SpHit;
		if (UCount) UCount--;
		else {
			if (SpriteON &&	SPONSwitch) RefreshSprite(prevline,dispmax,0);
			RefreshLine(prevline,dispmax-1);
			if (SpriteON &&	SPONSwitch) RefreshSprite(prevline,dispmax,1);
			prevline=dispmax;
			UCount=UPeriod;
			RefreshScreen();
		}
	}
	if (scanline>=MinLine && scanline<=MaxLine) {
		if (scanline==(io.VDC[RCR].W&1023)-64) {
			if (RasHitON &&	!UCount	&& dispmin<=scanline &&	scanline<=dispmax) {
				if (SpriteON &&	SPONSwitch) RefreshSprite(prevline,scanline,0);
				RefreshLine(prevline,scanline-1);
				if (SpriteON &&	SPONSwitch) RefreshSprite(prevline,scanline,1);
				prevline=scanline;
			}
			io.vdc_status|=VDC_RasHit;
			if (RasHitON) {
				//TRACE("rcr=%d\n", scanline);
				ret = INT_IRQ;
			}
		} else if (scroll) {
			if (scanline-1>prevline	&& !UCount) {
				int	tmpScrollX, tmpScrollY,	tmpScrollYDiff;
				tmpScrollX=ScrollX;
				tmpScrollY=ScrollY;
				tmpScrollYDiff=ScrollYDiff;
				ScrollX=oldScrollX;
				ScrollY=oldScrollY;
				ScrollYDiff=oldScrollYDiff;
				if (SpriteON &&	SPONSwitch) RefreshSprite(prevline,scanline-1,0);
				RefreshLine(prevline,scanline-2);
				if (SpriteON &&	SPONSwitch) RefreshSprite(prevline,scanline-1,1);
				prevline=scanline-1;
				ScrollX	= tmpScrollX;
				ScrollY	= tmpScrollY;
				ScrollYDiff = tmpScrollYDiff;
			}
		}
	} else {
		int rcr	= (io.VDC[RCR].W&1023)-64;
		if (scanline==rcr)
		{
//			ScrollYDiff = scanline;
			if (RasHitON) {
				//TRACE("rcr=%d\n", scanline);
				io.vdc_status |= VDC_RasHit;
				ret = INT_IRQ;
			}
		}
	}
	scroll=0;
	if (scanline==MaxLine+1) {
//	if (scanline==scanlines_per_frame-63) {
		//int J=Joysticks();
		//if (J&0x10000)
        //return INT_QUIT;
      if (Joysticks())
        return INT_QUIT;

		//io.JOY[0]=J;
      //io.JOY[1]=J; that's enough for 2nd player plays

		/* VRAM to SATB DMA */
		if (io.vdc_satb==1 || io.VDC[DCR].W&0x0010)
		{
			memcpy(SPRAM,VRAM+io.VDC[SATB].W*2,64*8);
			io.vdc_satb=1;
			io.vdc_status&=~VDC_SATBfinish;
		}
		if (ret==INT_IRQ)
			io.vdc_pendvsync = 1;
		else {
			//TRACE("vsync\n");
			//io.vdc_status|=VDC_InVBlank;
			if (VBlankON) {
				//TRACE("vsync=%d\n", scanline);
				ret = INT_IRQ;
			}
		}
	}
	else 
	if (scanline==min(MaxLine+5, scanlines_per_frame-1)) {
		if (io.vdc_satb) {
			io.vdc_status|=VDC_SATBfinish;
			io.vdc_satb = 0;
			if (SATBIntON) {
				//TRACE("SATB=%d\n", scanline);
				ret = INT_IRQ;
			}
/*		} else {
			io.vdc_status&=~VDC_SATBfinish;
			io.vdc_satb = 0;
*/		}
	} else if (io.vdc_pendvsync && ret!=INT_IRQ) {
		io.vdc_pendvsync = 0;
		//io.vdc_status|=VDC_InVBlank;
		if (VBlankON) {
			//TRACE("vsync=%d\n", scanline);
			ret = INT_IRQ;
		}
	}
	if (ret	== INT_IRQ) {
		if (!(io.irq_mask&IRQ1)) {
			io.irq_status|=IRQ1;
			//if (io.vdc_status&0x20)
			//TRACE("status=%02X\n", io.vdc_status);
			//TRACE("irq:scan %d\n ",scanline);
			return ret;
		}
	}
	return INT_NONE;
}

byte TimerInt(M6502 *R)
{
	if (io.timer_start) {
		io.timer_counter--;
		if (io.timer_counter > 128) {
			io.timer_counter = io.timer_reload;
			//io.irq_status &= ~TIRQ;
			if (!(io.irq_mask&TIRQ)) {
				io.irq_status |= TIRQ;
				//TRACE("tirq=%d\n",scanline);
				//TRACE("tirq\n");
				return INT_TIMER;
			}
		}
	}
	return INT_NONE;
}

/*
	Hit Chesk Sprite#0 and others
*/
int CheckSprites(void)
{
	int i,x0,y0,w0,h0,x,y,w,h;
	SPR *spr;

//      return FALSE;
// Very experimental ;)

	spr = (SPR*)SPRAM;
	x0 = spr->x;
	y0 = spr->y;
	w0 = (((spr->atr>>8 )&1)+1)*16;
	h0 = (((spr->atr>>12)&3)+1)*16;
	spr++;
	for(i=1;i<64;i++,spr++)	{
		x = spr->x;
		y = spr->y;
		w = (((spr->atr>>8 )&1)+1)*16;
		h = (((spr->atr>>12)&3)+1)*16;
		if ((x<x0+w0)&&(x+w>x0)&&(y<y0+h0)&&(y+h>y0)) return TRUE;
	}
	return FALSE;
}

static void plane2pixel(int no)
{
	unsigned long M;
	byte *C=VRAM+no*32;
	unsigned long L,*C2 = VRAM2+no*8;
	int j;
  for(j=0;j<8;j++,C+=2,C2++) {
    M=C[0];
    L =((M&0x88)>>3)|((M&0x44)<<6)|((M&0x22)<<15)|((M&0x11)<<24);
    M=C[1];
    L|=((M&0x88)>>2)|((M&0x44)<<7)|((M&0x22)<<16)|((M&0x11)<<25);
    M=C[16];
    L|=((M&0x88)>>1)|((M&0x44)<<8)|((M&0x22)<<17)|((M&0x11)<<26);
    M=C[17];
    L|=((M&0x88))|((M&0x44)<<9)|((M&0x22)<<18)|((M&0x11)<<27);
    C2[0] = L; //37261504
  }
}

#if 0
static void sprite2pixel(void *dst,void	*src,int h)
{
  int i;
  long *C2 = dst;
  byte *C = src;
  for(i=0;i<h*2;i++,C++,C2++){
	long L;
	byte M;
    M=C[0];
    L =((M&0x88)>>3)|((M&0x44)<<6)|((M&0x22)<<15)|((M&0x11)<<24);
    M=C[32];
    L|=((M&0x88)>>2)|((M&0x44)<<7)|((M&0x22)<<16)|((M&0x11)<<25);
    M=C[64];
    L|=((M&0x88)>>1)|((M&0x44)<<8)|((M&0x22)<<17)|((M&0x11)<<26);
    M=C[96];
    L|=((M&0x88))|((M&0x44)<<9)|((M&0x22)<<18)|((M&0x11)<<27);
	C2[0]=L;
/*
	M = C[0];
    L  =((M&0x8888)>>3)|((M&0x4444)<<14);
    LL =((M&0x2222)>>1)|((M&0x1111)<<16);
	M = C[16];
    L |=((M&0x8888)>>2)|((M&0x4444)<<15);
    LL|=((M&0x2222))|((M&0x1111)<<17);
	M = C[32];
    L |=((M&0x8888)>>1)|((M&0x4444)<<16);
    LL|=((M&0x2222)<<1)|((M&0x1111)<<18);
	M = C[64];
    L |=((M&0x8888))|((M&0x4444)<<17);
    LL|=((M&0x2222)<<2)|((M&0x1111)<<19);
	C2[0]=L;   //159D048C
	C2[1]=LL;  //37BF26AE
	C++;
	C2+=2;
*/
  }
}
#endif
/*
static long sp2pixel(byte *C)
{
	long L;
	byte M;
    M=C[0];
    L =((M&0x88)>>3)|((M&0x44)<<6)|((M&0x22)<<15)|((M&0x11)<<24);
    M=C[32];
    L|=((M&0x88)>>2)|((M&0x44)<<7)|((M&0x22)<<16)|((M&0x11)<<25);
    M=C[64];
    L|=((M&0x88)>>1)|((M&0x44)<<8)|((M&0x22)<<17)|((M&0x11)<<26);
    M=C[96];
    L|=((M&0x88))|((M&0x44)<<9)|((M&0x22)<<18)|((M&0x11)<<27);
	return L;
}
*/
static void sp2pixel(int no)
{
	byte M;
	byte *C;
	unsigned long *C2;
	int i;
	C=&VRAM[no*128];
	C2=&VRAMS[no*32];

	for(i=0;i<32;i++,C++,C2++){
		long L;
		M=C[0];
		L =((M&0x88)>>3)|((M&0x44)<<6)|((M&0x22)<<15)|((M&0x11)<<24);
		M=C[32];
		L|=((M&0x88)>>2)|((M&0x44)<<7)|((M&0x22)<<16)|((M&0x11)<<25);
		M=C[64];
		L|=((M&0x88)>>1)|((M&0x44)<<8)|((M&0x22)<<17)|((M&0x11)<<26);
		M=C[96];
		L|=((M&0x88))|((M&0x44)<<9)|((M&0x22)<<18)|((M&0x11)<<27);
		C2[0]=L;
	}
}

#define	PAL(c)	R[c]
#define	SPal	(Pal+256)

#ifdef ALLEGRO
extern BITMAP* XBuf;
#else
extern byte *XBuf;
#endif

#define	FC_W	io.screen_w
#define	FC_H	256
/*****************************************************************************

    Function: RefreshLine

    Description: draw tiles on screen
    Parameters: int Y1,int Y2 (lines to draw between)
    Return: nothing

*****************************************************************************/



void RefreshLine(int Y1,int Y2)
{
	int X1,XW,Line;
	int x,y,h,offset,Shift;

	byte *PP;//,*ZP;
	//TRACE("%d-%d,Scroll=%d\n",Y1,Y2,ScrollY-ScrollYDiff);
	Y2++;
	PP=XBuf->line[0]+WIDTH*(HEIGHT-FC_H)/2+(WIDTH-FC_W)/2+WIDTH*Y1;
//	if(!ScreenON || !BGONSwitch) memset(XBuf+Y1*WIDTH,Black,(Y2-Y1)*WIDTH);
//	else {
	if(ScreenON && BGONSwitch) {
		//TRACE("ScrollY=%d,diff=%d\n", ScrollY, ScrollYDiff);
		//TRACE("ScrollX=%d\n", ScrollX);
	y = Y1+ScrollY-ScrollYDiff;
	offset = y&7;
	h = 8-offset;
	if (h>Y2-Y1) h=Y2-Y1;
	y>>=3;
	PP-=ScrollX&7;
	XW=io.screen_w/8+1;
	Shift =	ScrollX&7;
//	{byte *Z=ZBuf+Y1*ZW;
//	for(Line=Y1;Line<Y2;Line++,Z+=ZW) Z[0]=0;
//	}

  for(Line=Y1;Line<Y2;y++) {
//    ZP = ZBuf+Line*ZW;
	x = ScrollX/8;
	y &= io.bg_h-1;
	for(X1=0;X1<XW;X1++,x++,PP+=8/*,ZP++*/){
		byte *R,*P,*C;//,*Z;
		unsigned long *C2;
		int no,i;
		x&=io.bg_w-1;
		no = ((word*)VRAM)[x+y*io.bg_w];
		R = &Pal[(no>>12)*16];
		no&=0xFFF;
		if (vchange[no]) { vchange[no]=0; plane2pixel(no);}
		C2 = &VRAM2[no*8+offset];
		C = &VRAM[no*32+offset*2];
		P = PP;
//		Z = ZP;
		for(i=0;i<h;i++,P+=WIDTH,C2++,C+=2/*,Z+=ZW*/) {
			unsigned long L;
			BYTE	J;

			J = (C[0]|C[1]|C[16]|C[17]);
			if (!J)	continue;

			L=C2[0];
			if (J&0x80) P[0]=PAL((L>>4)&15);
			if (J&0x40) P[1]=PAL((L>>12)&15);
			if (J&0x20) P[2]=PAL((L>>20)&15);
			if (J&0x10) P[3]=PAL((L>>28));
			if (J&0x08) P[4]=PAL((L)&15);
			if (J&0x04) P[5]=PAL((L>>8)&15);
			if (J&0x02) P[6]=PAL((L>>16)&15);
			if (J&0x01) P[7]=PAL((L>>24)&15);
//			L = J<<Shift;
//			Z[0]|=L>>8;Z[1]=L;
		}
	}
	Line+=h;
	PP+=WIDTH*h-XW*8;
	offset = 0;
	h = Y2-Line;
	if (h>8) h=8;
  }
  	}
	/* Refresh Sprite */
//	if (SpriteON) RefreshSprite(Y1,Y2);
}

#define	V_FLIP	0x8000
#define	H_FLIP	0x0800
#define	SPBG	0x80
#define	CGX	0x100

/*****************************************************************************

    Function: PutSprite

    Description: convert a sprite from VRAM to normal format
    Parameters: byte *P (the place where to draw i.e. XBuf[...])
                byte *C (the buffer toward the sprite to draw)
                unsigned long *C2
                byte *R (address of the palette of this sprite)
                int h (the number of line to draw)
                int inc (the value to increment the sprite buffer)
    Return:

*****************************************************************************/



static void PutSprite(byte *P,byte *C,unsigned long *C2,byte *R,int h,int inc)
{
	int i,J;
	unsigned long L;
	for(i=0;i<h;i++,C+=inc,C2+=inc,P+=WIDTH) {
		J = ((word*)C)[0]|((word*)C)[16]|((word*)C)[32]|((word*)C)[48];
      //fprintf(stderr,"%d\n",J);
		if (!J)	continue;
		L = C2[1];//sp2pixel(C+1);
		if (J&0x8000) P[0]=PAL((L>>4)&15);
		if (J&0x4000) P[1]=PAL((L>>12)&15);
		if (J&0x2000) P[2]=PAL((L>>20)&15);
		if (J&0x1000) P[3]=PAL((L>>28));
		if (J&0x0800) P[4]=PAL((L)&15);
		if (J&0x0400) P[5]=PAL((L>>8)&15);
		if (J&0x0200) P[6]=PAL((L>>16)&15);
		if (J&0x0100) P[7]=PAL((L>>24)&15);
		L = C2[0];//sp2pixel(C);
		if (J&0x80) P[8 ]=PAL((L>>4)&15);
		if (J&0x40) P[9 ]=PAL((L>>12)&15);
		if (J&0x20) P[10]=PAL((L>>20)&15);
		if (J&0x10) P[11]=PAL((L>>28));
		if (J&0x08) P[12]=PAL((L)&15);
		if (J&0x04) P[13]=PAL((L>>8)&15);
		if (J&0x02) P[14]=PAL((L>>16)&15);
		if (J&0x01) P[15]=PAL((L>>24)&15);
	}
}

static void PutSpriteHflip(byte	*P,byte	*C,unsigned long *C2,byte *R,int h,int inc)
{
	int i,J;
	unsigned long L;
	for(i=0;i<h;i++,C+=inc,C2+=inc,P+=WIDTH) {
		J = ((word*)C)[0]|((word*)C)[16]|((word*)C)[32]|((word*)C)[48];
		if (!J)	continue;
		L = C2[1];//sp2pixel(C+1);
		if (J&0x8000) P[15]=PAL((L>>4)&15);
		if (J&0x4000) P[14]=PAL((L>>12)&15);
		if (J&0x2000) P[13]=PAL((L>>20)&15);
		if (J&0x1000) P[12]=PAL((L>>28));
		if (J&0x0800) P[11]=PAL((L)&15);
		if (J&0x0400) P[10]=PAL((L>>8)&15);
		if (J&0x0200) P[9]=PAL((L>>16)&15);
		if (J&0x0100) P[8]=PAL((L>>24)&15);
		L = C2[0];//sp2pixel(C);
		if (J&0x80) P[7]=PAL((L>>4)&15);
		if (J&0x40) P[6]=PAL((L>>12)&15);
		if (J&0x20) P[5]=PAL((L>>20)&15);
		if (J&0x10) P[4]=PAL((L>>28));
		if (J&0x08) P[3]=PAL((L)&15);
		if (J&0x04) P[2]=PAL((L>>8)&15);
		if (J&0x02) P[1]=PAL((L>>16)&15);
		if (J&0x01) P[0]=PAL((L>>24)&15);
	}
}

static void PutSpriteM(byte *P,byte *C,unsigned	long *C2,byte *R,int h,int inc,byte *M,byte pr)
{
	int i,J;
	unsigned long L;
	for(i=0;i<h;i++,C+=inc,C2+=inc,P+=WIDTH,M+=WIDTH) {
		J = ((word*)C)[0]|((word*)C)[16]|((word*)C)[32]|((word*)C)[48];
		if (!J)	continue;
		L = C2[1];//sp2pixel(C+1);
		if ((J&0x8000)&&M[0]<=pr) P[0]=PAL((L>>4)&15);
		if ((J&0x4000)&&M[1]<=pr) P[1]=PAL((L>>12)&15);
		if ((J&0x2000)&&M[2]<=pr) P[2]=PAL((L>>20)&15);
		if ((J&0x1000)&&M[3]<=pr) P[3]=PAL((L>>28));
		if ((J&0x0800)&&M[4]<=pr) P[4]=PAL((L)&15);
		if ((J&0x0400)&&M[5]<=pr) P[5]=PAL((L>>8)&15);
		if ((J&0x0200)&&M[6]<=pr) P[6]=PAL((L>>16)&15);
		if ((J&0x0100)&&M[7]<=pr) P[7]=PAL((L>>24)&15);
		L = C2[0];//sp2pixel(C);
		if ((J&0x80)&&M[8 ]<=pr) P[8 ]=PAL((L>>4)&15);
		if ((J&0x40)&&M[9 ]<=pr) P[9 ]=PAL((L>>12)&15);
		if ((J&0x20)&&M[10]<=pr) P[10]=PAL((L>>20)&15);
		if ((J&0x10)&&M[11]<=pr) P[11]=PAL((L>>28));
		if ((J&0x08)&&M[12]<=pr) P[12]=PAL((L)&15);
		if ((J&0x04)&&M[13]<=pr) P[13]=PAL((L>>8)&15);
		if ((J&0x02)&&M[14]<=pr) P[14]=PAL((L>>16)&15);
		if ((J&0x01)&&M[15]<=pr) P[15]=PAL((L>>24)&15);
	}
}

static void PutSpriteHflipM(byte *P,byte *C,unsigned long *C2,byte *R,int h,int	inc,byte *M,byte pr)
{
	int i,J;
	unsigned long L;
	for(i=0;i<h;i++,C+=inc,C2+=inc,P+=WIDTH,M+=WIDTH) {
		J = ((word*)C)[0]|((word*)C)[16]|((word*)C)[32]|((word*)C)[48];
		if (!J)	continue;
		L = C2[1];//sp2pixel(C+1);
		if ((J&0x8000)&&M[15]<=pr) P[15]=PAL((L>>4)&15);
		if ((J&0x4000)&&M[14]<=pr) P[14]=PAL((L>>12)&15);
		if ((J&0x2000)&&M[13]<=pr) P[13]=PAL((L>>20)&15);
		if ((J&0x1000)&&M[12]<=pr) P[12]=PAL((L>>28));
		if ((J&0x0800)&&M[11]<=pr) P[11]=PAL((L)&15);
		if ((J&0x0400)&&M[10]<=pr) P[10]=PAL((L>>8)&15);
		if ((J&0x0200)&&M[9]<=pr) P[9]=PAL((L>>16)&15);
		if ((J&0x0100)&&M[8]<=pr) P[8]=PAL((L>>24)&15);
		L = C2[0];//sp2pixel(C);
		if ((J&0x80)&&M[7]<=pr)	P[7]=PAL((L>>4)&15);
		if ((J&0x40)&&M[6]<=pr)	P[6]=PAL((L>>12)&15);
		if ((J&0x20)&&M[5]<=pr)	P[5]=PAL((L>>20)&15);
		if ((J&0x10)&&M[4]<=pr)	P[4]=PAL((L>>28));
		if ((J&0x08)&&M[3]<=pr)	P[3]=PAL((L)&15);
		if ((J&0x04)&&M[2]<=pr)	P[2]=PAL((L>>8)&15);
		if ((J&0x02)&&M[1]<=pr)	P[1]=PAL((L>>16)&15);
		if ((J&0x01)&&M[0]<=pr)	P[0]=PAL((L>>24)&15);
	}
}

static void PutSpriteMakeMask(byte *P,byte *C,unsigned long *C2,byte *R,int h,int inc,byte *M,byte pr)
{
	int i,J;
	unsigned long L;
	for(i=0;i<h;i++,C+=inc,C2+=inc,P+=WIDTH,M+=WIDTH) {
		J = ((word*)C)[0]|((word*)C)[16]|((word*)C)[32]|((word*)C)[48];
		if (!J)	continue;
		L = C2[1];//sp2pixel(C+1);
		if (J&0x8000) {P[0]=PAL((L>>4)&15);  M[0]=pr;}
		if (J&0x4000) {P[1]=PAL((L>>12)&15); M[1]=pr;}
		if (J&0x2000) {P[2]=PAL((L>>20)&15); M[2]=pr;}
		if (J&0x1000) {P[3]=PAL((L>>28));    M[3]=pr;}
		if (J&0x0800) {P[4]=PAL((L)&15);     M[4]=pr;}
		if (J&0x0400) {P[5]=PAL((L>>8)&15);  M[5]=pr;}
		if (J&0x0200) {P[6]=PAL((L>>16)&15); M[6]=pr;}
		if (J&0x0100) {P[7]=PAL((L>>24)&15); M[7]=pr;}
		L = C2[0];//sp2pixel(C);
		if (J&0x80) {P[8 ]=PAL((L>>4)&15);  M[8]=pr;}
		if (J&0x40) {P[9 ]=PAL((L>>12)&15); M[9]=pr;}
		if (J&0x20) {P[10]=PAL((L>>20)&15); M[10]=pr;}
		if (J&0x10) {P[11]=PAL((L>>28));    M[11]=pr;}
		if (J&0x08) {P[12]=PAL((L)&15);	    M[12]=pr;}
		if (J&0x04) {P[13]=PAL((L>>8)&15);  M[13]=pr;}
		if (J&0x02) {P[14]=PAL((L>>16)&15); M[14]=pr;}
		if (J&0x01) {P[15]=PAL((L>>24)&15); M[15]=pr;}
	}
}

static void PutSpriteHflipMakeMask(byte	*P,byte	*C,unsigned long *C2,byte *R,int h,int inc,byte	*M,byte	pr)
{
	int i,J;
	unsigned long L;
	for(i=0;i<h;i++,C+=inc,C2+=inc,P+=WIDTH,M+=WIDTH) {
		J = ((word*)C)[0]|((word*)C)[16]|((word*)C)[32]|((word*)C)[48];
		if (!J)	continue;
		L = C2[1];//sp2pixel(C+1);
		if (J&0x8000) {P[15]=PAL((L>>4)&15);  M[15]=pr;}
		if (J&0x4000) {P[14]=PAL((L>>12)&15); M[14]=pr;}
		if (J&0x2000) {P[13]=PAL((L>>20)&15); M[13]=pr;}
		if (J&0x1000) {P[12]=PAL((L>>28));    M[12]=pr;}
		if (J&0x0800) {P[11]=PAL((L)&15);     M[11]=pr;}
		if (J&0x0400) {P[10]=PAL((L>>8)&15);  M[10]=pr;}
		if (J&0x0200) {P[9]=PAL((L>>16)&15);  M[9]=pr;}
		if (J&0x0100) {P[8]=PAL((L>>24)&15);  M[8]=pr;}
		L = C2[0];//sp2pixel(C);
		if (J&0x80) {P[7]=PAL((L>>4)&15);  M[7]=pr;}
		if (J&0x40) {P[6]=PAL((L>>12)&15); M[6]=pr;}
		if (J&0x20) {P[5]=PAL((L>>20)&15); M[5]=pr;}
		if (J&0x10) {P[4]=PAL((L>>28));	  M[4]=pr;}
		if (J&0x08) {P[3]=PAL((L)&15);	  M[3]=pr;}
		if (J&0x04) {P[2]=PAL((L>>8)&15);  M[2]=pr;}
		if (J&0x02) {P[1]=PAL((L>>16)&15); M[1]=pr;}
		if (J&0x01) {P[0]=PAL((L>>24)&15); M[0]=pr;}
	}
}

/*****************************************************************************

    Function: RefreshSprite

    Description: draw all sprites between two lines
    Parameters: int Y1, int Y2 (the 'ordonee' to draw between), BYTE bg (do we draw fg or bg sprites)
    Return: absolutly nothing

*****************************************************************************/



void RefreshSprite(int Y1,int Y2,BYTE bg)
{
	int n;
	SPR *spr;
	static int usespbg = 0;

	//frame++;

	spr = (SPR*)SPRAM + 63;

	if (bg==0)
		usespbg=0;

	for(n=0;n<64;n++,spr--){
		int x,y,no,atr,inc,cgx,cgy;
		byte *R,*C;
		unsigned long *C2;
		int	pos;
		int h,t,i,j;
		int y_sum;
		int spbg;

		atr=spr->atr;
		spbg = (atr>>7)&1;
		if (spbg != bg)
			continue;
		y = (spr->y&1023)-64;
		x = (spr->x&1023)-32;
		no= spr->no&2047;
		cgx = (atr>>8)&1;
		cgy = (atr>>12)&3;
		cgy |= cgy>>1;
		no = (no>>1)&~(cgy*2+cgx);
		if (y>=Y2 || y+(cgy+1)*16<Y1 ||	x>=FC_W	|| x+(cgx+1)*16<0) continue;

		R = &SPal[(atr&15)*16];
		for (i=0;i<cgy*2+cgx+1;i++) {
			if (vchanges[no+i]) {
				vchanges[no+i] = 0;
				sp2pixel(no+i);
			}
			if (!cgx) i++;
		}
		C = &VRAM[no*128];
		C2 = &VRAMS[no*32];
		pos = WIDTH*(HEIGHT-FC_H)/2+(WIDTH-FC_W)/2+WIDTH*y+x;
		inc = 2;
		if (atr&V_FLIP)	{ inc=-2; C+=15*2+cgy*256; C2+=15*2+cgy*64;}
		y_sum =	0;
		//printf("(%d,%d,%d,%d,%d)",x,y,cgx,cgy,h);
		//TRACE("Spr#%d,no=%d,x=%d,y=%d,CGX=%d,CGY=%d,xb=%d,yb=%d\n", n, no, x, y, cgx, cgy, atr&H_FLIP, atr&V_FLIP);
		for(i=0;i<=cgy;i++) {
			t = Y1-y-y_sum;
			h = 16;
			if (t>0) {
				C+=t*inc;
				C2+=t*inc;
				h-=t;
				pos+=t*WIDTH;
			}
			if (h>Y2-y-y_sum)
           h = Y2-y-y_sum;
			if (spbg==0){
				usespbg=1;
				if (atr&H_FLIP){
				  for(j=0;j<=cgx;j++)
					PutSpriteHflipMakeMask(XBuf->line[0]+pos+(cgx-j)*16,C+j*128,C2+j*32,R,h,inc,SPM+pos+(cgx-j)*16,n);
				}else{
				  for(j=0;j<=cgx;j++)
					PutSpriteMakeMask(XBuf->line[0]+pos+j*16,C+j*128,C2+j*32,R,h,inc,SPM+pos+j*16,n);
				}
			} else if (usespbg) {
				if (atr&H_FLIP){
				  for(j=0;j<=cgx;j++)
					PutSpriteHflipM(XBuf->line[0]+pos+(cgx-j)*16,C+j*128,C2+j*32,R,h,inc,SPM+pos+(cgx-j)*16,n);
				}else{
				  for(j=0;j<=cgx;j++)
					PutSpriteM(XBuf->line[0]+pos+j*16,C+j*128,C2+j*32,R,h,inc,SPM+pos+j*16,n);
				}
			} else {
				if (atr&H_FLIP){
				  for(j=0;j<=cgx;j++)
					PutSpriteHflip(XBuf->line[0]+pos+(cgx-j)*16,C+j*128,C2+j*32,R,h,inc);
				}else{
				  for(j=0;j<=cgx;j++)
					PutSprite(XBuf->line[0]+pos+j*16,C+j*128,C2+j*32,R,h,inc);
				}
			}
			pos+=h*WIDTH;
			C+=h*inc+16*7*inc;
			C2+=h*inc+16*inc;
			y_sum+=16;
		}
	}
 return ;
}

char tmp_str[10];
extern int vheight;
extern char* sbuf[];

/*****************************************************************************

    Function: RefreshScreen

    Description: refresh screen
    Parameters: none
    Return: nothing

*****************************************************************************/

void RefreshScreen(void)
{
//	int dispmin,dispmax;

	frame++;
//	dispmin	= (MaxLine-MinLine>MAXDISP ? MinLine+((MaxLine-MinLine-MAXDISP+1)>>1) :	MinLine);
//	dispmax	= (MaxLine-MinLine>MAXDISP ? MaxLine-((MaxLine-MinLine-MAXDISP+1)>>1) :	MaxLine);
	PutImage();
//   textout(screen,font,itoa(io.PSG[4][7],tmp_str,10),10,0,-1);
//   textout(screen,font,itoa(io.PSG[5][7],tmp_str,10),50,0,-1);
//   for(dispmin=0;dispmin<6;dispmin++)
//     line(screen,220+dispmin*4,150,220+dispmin*4,150-abs(sbuf[dispmin][0]),-1);

	memset(XBuf->line[0]+MinLine*WIDTH,Pal[0],(MaxLine-MinLine)*WIDTH);
	memset(SPM+MinLine*WIDTH,0,(MaxLine-MinLine)*WIDTH);
   return ;
}

static tmp_dir_created=0;
// To know whether we got to delete temporary path
// If someone knows how to use build-in extraction then .. do it

/*****************************************************************************

    Function: CartLoad

    Description: load a card (I would like to use un unzip library here)
    Parameters: char* name (the filename to load)
    Return: -1 on error else 0

*****************************************************************************/



int CartLoad(char *name)
{
	FILE *fp;
	int fsize;
	char tmp_path[80];

	strupr(name); // Shouldn't be useful but...
        if (strstr(name,".ZIP"))
          {
           //strcpy(tmp_path,name);
           //if (strrchr(tmp_path,'\\'))
             //*(char*)strrchr(tmp_path,'\\')='\0';

//           while (i<strlen(name))
//             if (tmp_path[i++]='/')
//               tmp_path[i-1]='\\';


//           chdir(tmp_path);
           {
             char tmp_buf[128];
             sprintf(tmp_buf,"%sHU-GO!.TMP/",short_exe_name);
             mkdir(tmp_buf,0);
             tmp_dir_created=1;
           }
           //errno=0;
           //strcpy(tmp_path,get_filename(name));
            {
             char tmp_char[128],x;
             textmode(3);
             sprintf(tmp_char,"PKUNZIP %s %sHU-GO!.TMP ",name,short_exe_name);
             for (x=0;tmp_char[x] ;x++ )
                if (tmp_char[x]=='/')
                  tmp_char[x]='\\';
                system(tmp_char);
            }
//         strcpy(tmp_path,"HU-GO!.TMP/");
//         strcat(tmp_path,get_filename(name));
//         strcpy(&tmp_path[strlen(tmp_path)-4],".PCE");
           sprintf(tmp_path,"%sHU-GO!.TMP/%sPCE",short_exe_name,short_cart_name);
           fp=fopen(tmp_path,"rb");
          }
        else
	   fp=fopen(name,"rb");
	if (fp==NULL) {
	  #ifndef FINAL_RELEASE
		fprintf(stderr,"%s not found.\n",(tmp_dir_created?tmp_path:name));
	  #endif
		if (!index(name,'.')) //if dot omitted, we try with PCE extension
		  {
		    strcat(name,".PCE");
		    return CartLoad(name);
		  };

		if (strstr(name,".PCE")) //if filename with .PCE doesn't exist, it may be in ZIP
		  {
		    strcpy(&name[strlen(name)-4],".ZIP");
		    return CartLoad(name);
		   };

		return -1;
	}
	strcpy(cart_name,name);
	fseek(fp,0,SEEK_END);
	fsize =	ftell(fp);
	fseek(fp,fsize&0x1fff,SEEK_SET);
	//printf("seekptr %x",ftell(fp));
	fsize&=~0x1fff;
	ROM = (BYTE *)malloc(fsize);
	ROM_size = fsize/0x2000;
	//printf("ROM size:%x\n",fsize);
	fread(ROM,1,fsize,fp);
	fclose(fp);
/*	if (strstr(name, "populous.pce"))
	{
		fprintf(stderr,"populus\n");
		populus = 1;
	}
	else
		populus = 0; */
	return 0;
}

/*****************************************************************************

    Function: pokebyte

    Description: set a value in the ram to a specified value
    Parameters: none
    Return: 0

*****************************************************************************/



char pokebyte()
{
    char tmp_str[10],new_val,index=0;
    unsigned addr;

      while (keypressed()) readkey(); // Flushing keys
      while ((index<10)	&& ((tmp_str[index++]=readkey()	& 0xFF)!=13)) ;
      tmp_str[index-1]=0;
      addr=atoi(tmp_str);

      while (keypressed()) readkey(); // Flushing keys
      index=0;
      while ((index<10)	&& ((tmp_str[index++]=readkey()	& 0xFF)!=13)) ;
      tmp_str[index-1]=0;
      new_val=atoi(tmp_str);

      RAM[addr]=new_val;

      {
       char* tmp_buf=(char*)alloca(100);
       sprintf(tmp_buf,"BYTE AT %d SET TO %d",addr,new_val);
       set_message(tmp_buf);
       message_delay=180;
       }


      return 0;
 }

extern int blit_x;
extern int blit_y;

/*****************************************************************************

    Function: searchbyte

    Description: search the ram for a particuliar value
    Parameters: none
    Return: 1 on error

*****************************************************************************/



char searchbyte()
{
    char tmp_str[10];
    unsigned short index=0,tmp_word,last_index;
    char data_filename[80],old_filename[80];
    char first_research=1;
    FILE *D,*O;
    unsigned char to_search;
      while (keypressed()) readkey(); // Flushing keys

      while ((index<10)	&& ((tmp_str[index++]=readkey()	& 0xFF)!=13)) ;
      tmp_str[index-1]=0;

      to_search=atoi(tmp_str);

      strcpy(old_filename,short_cart_name);
      strcpy(data_filename,short_cart_name);
      strcat(data_filename,"FP1");

      if (exists((char*)strcat(old_filename,"FP0")))
       {
	     if (!(O=fopen(old_filename,"rb")))
	       return 1;
	     first_research=0;
       }

      if (!(D=fopen(data_filename,"wb")))
	     return 1;
      //textout(screen,font,"Testing!",blit_x,blit_y,-1);
      tmp_str[9]=0;
      for (index=0;index<0x8000;index++)
	 {
//          textout(screen,font,itoa(index,tmp_str,10),0,10,1);
	  if ((unsigned char)RAM[index]==to_search)
	    {

	     if	(first_research)
		    fwrite(&index,2,1,D);
	     else
		  {
		 //fseek(O,0,SEEK_SET);
		   while (!(feof(O)))
		    {
		     fread(&tmp_word,2,1,O);
		     if	(tmp_word>=index)
		       {
			      fseek(O,-2,SEEK_CUR);
			      break;
		       }
		   }

		 if (index==tmp_word)
		   {
		     fwrite(&index,2,1,D);
           last_index=index;
		     //textout(screen,font,itoa(index,tmp_str,10),blit_x,blit_y+(tmp_str[9]+=8,tmp_str[9]%=200),-1);
		   }
		 }//search for old occurences
	   }
	  }

      if (!first_research)
	     fclose(O);
      fclose(D);

      rename(data_filename,old_filename);
      if (!file_size(old_filename))
	     {
          //textout(screen,font,"Search failed",0,0,-1);
          set_message("SEARCH FAILED");
          message_delay=180;
	       unlink(old_filename);
	       //readkey();
	       return 1;
        }

      if (file_size(old_filename)==2)
        {
         char* tmp_buf=(char*)alloca(100);
         sprintf(tmp_buf,"FOUND AT %d",last_index);
         set_message(tmp_buf);
         message_delay=60*5;
         }
      else
        {
         set_message("STILL NEED TO SEARCH");
         message_delay=180;
         }
      //textout(screen,font,itoa(file_size(old_filename)/2,tmp_str,10),0,0,1);
      //readkey();
      return 0;

    }

#define	VRAMSIZE	0x20000

/*****************************************************************************

    Function: savegame

    Description: save a game using allegro packing functions
    Parameters: none
    Return: 1 on error, else 0

*****************************************************************************/


char savegame()
  {
   PACKFILE	*fp;
   //,final[80];

//        while ((cart_name[0]) && (final[tmp]=cart_name[tmp++])!='.');
//        final[tmp]=0;

  // sprintf(final,"%s%s.SAV",sav_path,short_cart_name);

//	strcpy(final,short_cart_name);
//	strcat(final,"SAV");
	if (!(fp=pack_fopen(sav_path,F_WRITE_PACKED)))
	  return 1;

   pack_fwrite(RAM, 0x8000, fp);
	pack_fwrite(VRAM, VRAMSIZE, fp);
	pack_fwrite(SPRAM, 64*4*sizeof(short), fp);
	pack_fwrite(Pal, 512, fp);
	pack_fwrite(&scanline, sizeof(int), fp);
	pack_fwrite(&io, sizeof(IO), fp);
	pack_fwrite(&M, sizeof(M6502), fp);
	if (populus)
		pack_fwrite(PopRAM, PopRAMsize, fp);
	return pack_fclose(fp);
   }

/*****************************************************************************

    Function: loadgame

    Description: load a saved game using allegro packing functions
    Parameters: none
    Return: 1 on error, else 0

*****************************************************************************/

char loadgame()
  {
   	PACKFILE *fp;
	char tmp=0;
   //,final[80];

//        while ((cart_name[0]) && (final[tmp]=cart_name[tmp++])!='.');
//        final[tmp]=0;
//	strcpy(final,short_cart_name);
//	strcat(final,"SAV");
   //sprintf(final,"%s%s.SAV",sav_path,short_cart_name);

	if (!(fp=pack_fopen(sav_path,F_READ_PACKED)))
	  return 1;
	pack_fread(RAM, 0x8000, fp);
	pack_fread(VRAM, VRAMSIZE, fp);
	pack_fread(SPRAM,	64*4*sizeof(short), fp);
	pack_fread(Pal, 512, fp);
	pack_fread(&scanline, sizeof(int), fp);
	pack_fread(&io, sizeof(IO), fp);
	pack_fread(&M, sizeof(M6502), fp);

	if (populus)
		pack_fread(PopRAM, PopRAMsize, fp);
	for (tmp = 0; tmp < 8; tmp++)
		bank_set(tmp, M.MPR[tmp]);
	memset(vchange , 1, VRAMSIZE/32 );
	memset(vchanges, 1, VRAMSIZE/128);

	pack_fclose(fp);
   return 0;
   }


void ResetPCE(M6502 *M)
{
	int i;


	memset(M,0,sizeof(*M));
	memset(SPRAM,0,64*8);

	TimerCount = TimerPeriod;
	M->IPeriod = IPeriod;
	M->TrapBadOps =	1;
	memset(&io, 0, sizeof(IO));
	scanline = 0;
	io.vdc_status=0;//VDC_InVBlank;
	io.vdc_inc = 1;
	io.minline = 0;
	io.maxline = 255;
	io.irq_mask = 0;
	io.psg_volume =	0;
	io.psg_ch = 0;
	for (i = 0; i <	6; i++)
	{
		io.PSG[i][4] = 0x80;
	}
	CycleOld = 0;
	Reset6502(M);
	//printf("reset PC=%04x ",M->PC.W);
}

unsigned short NO_ROM=0xFFFF;

int InitPCE(char *name,	char *backmemname)
{
	int i=0,ROMmask;
	unsigned long CRC;
	int dummy;
   char* tmp_dummy;

//	strupr(name);
//	cart_name = name;
   if (!name)
     return -1;

   tmp_dummy=(char*)(strrchr(cart_name,'/')+1);
	while ((tmp_dummy[i]) && (short_cart_name[i++]=tmp_dummy[i])!='.') ;

   if (strlen(short_cart_name))
    if (short_cart_name[strlen(short_cart_name)-1]!='.')
     {
      short_cart_name[strlen(short_cart_name)+1]=0;
      short_cart_name[strlen(short_cart_name)]='.';
     }

   sprintf(sav_path,"%sSAV/%sSAV",short_exe_name,short_cart_name);

	if (CartLoad(name))
     return -1;

	CRC=CRC_file(name); // I'm doing it only here 'coz cartload set name

	DMYROM=(BYTE *)malloc(0x2000);
	memset(DMYROM,NODATA,0x2000);
	WRAM=(BYTE *)malloc(0x2000);
	memset(WRAM,0,0x2000);
	VRAM=(BYTE *)malloc(VRAMSIZE);
	VRAM2=(unsigned long *)malloc(VRAMSIZE);
	VRAMS=(unsigned long *)malloc(VRAMSIZE);
	//memset(VRAM,0,VRAMSIZE);
	IOAREA=(BYTE *)malloc(0x2000);
	memset(IOAREA,0xFF,0x2000);
	vchange	= (BYTE *)malloc(VRAMSIZE/32);
	memset(vchange,1,VRAMSIZE/32);
	vchanges = (BYTE *)malloc(VRAMSIZE/128);
	memset(vchanges,1,VRAMSIZE/128);

	for (dummy=0;dummy<NB_ROM;dummy++)
	  if (CRC==ROM_LIST[dummy].CRC)
	     NO_ROM=dummy;

   if (ROM_LIST[NO_ROM].flags&PINBALL_KEY)
     for (dummy=0;dummy<5;dummy++)
        {
         joy_mapping[dummy][J_II]=KEY_RSHIFT;
         joy_mapping[dummy][J_LEFT]=KEY_LSHIFT;
         joy_mapping[dummy][J_I]=KEY_STOP;
         joy_mapping[dummy][J_RIGHT]=KEY_Z;
        }


   if (ROM_LIST[NO_ROM].flags&TWO_PART_ROM)
     ROM_size=0x30;
   // Used for example with Devil Crush 512Ko

	ROMmask	= 1;
	while(ROMmask<ROM_size)	ROMmask<<=1;
	ROMmask--;
#ifndef FINAL_RELEASE
	fprintf(stderr,"ROMmask=%02X, ROM_size=%02X\n",	ROMmask, ROM_size);
#endif
	for(i=0;i<0xF7;i++)
	{
		if (ROM_size == 0x30)
		{
			switch (i&0x70)
			{
			case 0x00:
			case 0x10:
			case 0x50:
				ROMMap[i]=ROM+(i&ROMmask)*0x2000;
				break;
			case 0x20:
			case 0x60:
				ROMMap[i]=ROM+((i-0x20)&ROMmask)*0x2000;
				break;
			case 0x30:
			case 0x70:
				ROMMap[i]=ROM+((i-0x10)&ROMmask)*0x2000;
				break;
			case 0x40:
				ROMMap[i]=ROM+((i-0x20)&ROMmask)*0x2000;
				break;
			}
		}
		else
			ROMMap[i]=ROM+(i&ROMmask)*0x2000;
	}
//		ROMMap[i]=ROM+(i%ROM_size+i/ROM_size*0x10)*0x2000;
/*		if (((i&ROMmask)+i/(ROMmask+1)) < ROM_size)
			ROMMap[i]=ROM+((i&ROMmask)+i/(ROMmask+1)*0x20)*0x2000;
		else
			ROMMap[i]=ROM;
*///		ROMMap[i]=ROM+(i&ROMmask)*0x2000;
	if (NO_ROM!=0xFFFF)
     {
#ifndef FINAL_RELEASE
	    fprintf(stderr,"ROM NAME : %s\n",ROM_LIST[NO_ROM].name);
#endif
       set_message(ROM_LIST[NO_ROM].name);
       message_delay=60*5;
     }
   else
     {
       set_message("UNKNOWN ROM");
       message_delay=60*5;
     }
	//if (populus)
	if ((NO_ROM==NO_POPULOUS1) || (NO_ROM==NO_POPULOUS2))
	{
		populus	= TRUE;
#ifndef FINAL_RELEASE
		fprintf(stderr,"POPULOUS DETECTED!!!\n");
#endif
		if (!(PopRAM=(byte*)malloc(PopRAMsize)))
		   perror("Not enough mem!");
		ROMMap[0x40] = PopRAM;
		ROMMap[0x41] = PopRAM +	0x2000;
		ROMMap[0x42] = PopRAM +	0x4000;
		ROMMap[0x43] = PopRAM +	0x6000;
	}
	else
	{
	  populus = FALSE;
	  PopRAM=NULL;
	}
/*	ROMMap[0x80] = PopRAM + (0)*0x2000;
	ROMMap[0x81] = PopRAM + (1)*0x2000;
	ROMMap[0x82] = PopRAM + (2)*0x2000;
	ROMMap[0x83] = PopRAM + (3)*0x2000;
	ROMMap[0x84] = PopRAM + (4)*0x2000;
	ROMMap[0x85] = PopRAM + (5)*0x2000;
	ROMMap[0x86] = PopRAM + (6)*0x2000;
	ROMMap[0x87] = PopRAM + (7)*0x2000;
*/	ROMMap[0xF7]=WRAM;
	ROMMap[0xF8]=RAM;
	ROMMap[0xF9]=RAM+0x2000;
	ROMMap[0xFA]=RAM+0x4000;
	ROMMap[0xFB]=RAM+0x6000;
	ROMMap[0xFF]=IOAREA; //NULL; /* NULL = I/O area */


	{
	FILE *fp;
	fp = fopen(backmemname,	"rb");
	if (fp == NULL)
		fprintf(stderr,"Can't open %s\n", backmemname);
	else
	  {
		fread(WRAM, 0x2000, 1, fp);
		fclose(fp);
	  }
	}

	return 0;
}

int RunPCE(void)
{
//	M6502 M;
	ResetPCE(&M);
//	Run6502(&M);
	Run6502();
	return 1;
}

void delete_file_tmp(char* name,int dummy,int dummy2)
 {
  delete_file(name);
  return;
 };

void TrashPCE(char *backmemname)
{
	FILE *fp;

	if (!(fp = fopen(backmemname,	"wb")))
		fprintf(stderr,"Can't open %s\n", backmemname);
	else
	{
		fwrite(WRAM, 0x2000, 1,	fp);
		fclose(fp);
	}

	if (tmp_dir_created)
	  {
	    for_each_file("HU-GO!.TMP/*.*",32,delete_file_tmp,0);
	    rmdir("HU-GO!.TMP");
	  }
	if (IOAREA) free(IOAREA);
	if (vchange) free(vchange);
	if (vchanges) free(vchanges);
	if (DMYROM) free(DMYROM);
	if (WRAM) free(WRAM);
	if (VRAM) free(VRAM);
	if (VRAM2) free(VRAM2);
	if (VRAMS) free(VRAMS);
	if (ROM) free(ROM);
	if (PopRAM) free (PopRAM);

   return ;
};

/*int JoyStick(void)
{
	return Joysticks();
} */

void set_opt(char *next,char* buffer)
  {
   char* tmp_ptr;
   unsigned long value;
   //fprintf(stderr,"%s\n",buffer);
   value=strtoul(buffer,&tmp_ptr,0);
   if (tmp_ptr==buffer)
     return ; // We got a value of 0 meaning no true value, no changes to next_arg
   if ((*next>=0x10) && (*next<=0x5A))
     { //Input stuff
       joy_mapping[((*next) >> 4) - 1 ][ (*next) & 0xF] = value;
       *next=0;
      }

   return ;
   }

void identify_opt(char *next,char* buffer)
  {
   char tmp_str[10],x,y;
   memset(tmp_str,0,10);

   for (x=1;x<=5;x++)
      {  // for each joystick
        for (y=0;y<10;y++)
           {
            strcpy(tmp_str,joy_str[y]);
            tmp_str[strlen(tmp_str)+1]=0;
            tmp_str[strlen(tmp_str)]=x+0x30;

            if (stricmp(tmp_str,buffer)==0)
              {
                *next=x*16+y;
                return ;
              }
           }
      }

   // If there, we haven't found any input related stuff

   return ;
   }


char set_arg(char nb_arg,char* val)
  {
     if (!val)
       {
         fprintf(stderr,"No value for %c arg\n",nb_arg);
         return 1;
       };
     switch (nb_arg)
       {
              case 'v' :
                   vmode=atoi(val);
                   return 0;
              case 's' :
                   smode=atoi(val);
                   return 0;
              case 'j' :
                   nb_joy=atoi(val);
                   nb_joy=min(nb_joy,5);
                   nb_joy=max(1,nb_joy);
                   //io.joy_counter=nb_joy;
                     // nb_joy = [| 1 .. 5 |]
                   return 0;
              default:
                   fprintf(stderr,"Unrecognized option : %c\n",nb_arg);
                   return 1;
       }
   };


#ifdef CHRONO
unsigned nb_used[256],time_used[256];
#endif

#ifndef FINAL_RELEASE
extern int mseq(unsigned*);
extern void mseq_end();
extern void WriteBuffer_end();
extern void write_psg_end();
extern void WriteBuffer(char*,int,unsigned);
#endif

FILE * out_snd;

int main(int argc,char *argv[])
{
	char *bmdefault=0,backup_mem[80];
   char _BACKUP_DAT[]="BACKUP.DAT";
//	uclock_t t0,t1;
	PALETTE	P;
	char i,tmp_path[80];
   char next_arg=0,arg_error=0;
   FILE* F;

   #ifdef CHRONO
	  unsigned timax=0,inst_max=0;

      for (vmode=0;vmode<256;vmode++)
	     time_used[vmode]=nb_used[vmode]=0;

   #endif

  _crt0_startup_flags|=_CRT0_FLAG_NO_LFN;
  // Disable long filename to avoid mem waste in select_rom func.

   { //First, a little trick to init random functions
  struct timeb t;
  ftime(&t);
  srandom  ((char)t.time);
  fprintf(stderr,"seed ~= %d\n",(char)t.time);
    }


    #ifdef ALLEGRO
	     allegro_init();
    #endif


	strcpy(short_exe_name,argv[0]);
	for (i=0;short_exe_name[i];i++)
	   if (short_exe_name[i]=='\\')
		short_exe_name[i]='/';

	if (strrchr(short_exe_name,'/'))
	  *(char*)(strrchr(short_exe_name,'/')+1)=0;
   // add a trailing slash


	strcpy(tmp_path,short_exe_name);
	strcat(tmp_path,"HU-GO!.TGA");

	set_gfx_mode(GFX_AUTODETECT,320,200,0,0);
	XBuf=load_tga(tmp_path,(RGB*)&P);

	set_palette(P);

   (*fade_in_proc[rand()%nb_fadein])(XBuf,0,0,320,200);
	//blit(XBuf,screen,0,0,0,0,320,200);
   // Now the logo is displayed, let's be useful instead of wait

   destroy_bitmap(XBuf);

   strcpy(tmp_path,short_exe_name);
   strcat(tmp_path,"HU-GO!.INI");

// Default value for first input
for (next_arg=0;next_arg<5;next_arg++ )
   {
    joy_mapping[next_arg][J_DOWN]=KEY_DOWN;
    joy_mapping[next_arg][J_UP]=KEY_UP;
    joy_mapping[next_arg][J_LEFT]=KEY_LEFT;
    joy_mapping[next_arg][J_RIGHT]=KEY_RIGHT;
    joy_mapping[next_arg][J_SELECT]=KEY_TAB;
    joy_mapping[next_arg][J_START]=KEY_ENTER;
    joy_mapping[next_arg][J_I]=KEY_ALT;
    joy_mapping[next_arg][J_II]=KEY_SPACE;
    joy_mapping[next_arg][J_AUTOI]=KEY_DOWN;
    joy_mapping[next_arg][J_AUTOII]=KEY_DOWN;
   }

if (!(F=fopen(tmp_path,"rb")))
     { // if the INI file exist
   next_arg=0;
   while (!(feof(F)))
     {
      char buf[100];
labels_are_bad:
      fscanf(F,"%s\n",buf);
      if (*buf=='{')
        {
         while (!strpbrk(buf,"}"))
           fscanf(F,"%s\n",buf);
         goto labels_are_bad;
        }

      if (next_arg)
        set_opt(&next_arg,buf);
      else
        identify_opt(&next_arg,buf);
      };

   fclose(F);

   };

   // Now we have parsed the INI file
   // We can take care of the option line

      next_arg=0;
      vmode=0;
      smode=-1;
      for(i=1;i<argc;i++)
        if (!next_arg)
                {
                   if (strchr(argv[i],'-'))
                     {
                      if (strlen(argv[i])==2)
                        next_arg=argv[i][1];
                      else
                        arg_error|=set_arg(argv[i][1],(char*)&argv[i][2]);
                     }
                   else
                     {
                      if (!cart_name)
                        {
                         strupr(argv[i]);
                         cart_name=argv[i];
                         {int x;
                          for (x=0;x<strlen(cart_name);x++ )
                             if (cart_name[x]=='\\')
                               cart_name[x]='/';
                          }
                         }
                      else
                        if (!bmdefault)
                          {
                           strupr(argv[i]);
                           bmdefault=argv[i];
                           }
                        else
                          {
                            //fprintf(stderr,"Unrecognised option : %s\n",argv[i]);
                            arg_error=1;
                          };
                        }
                }
              else
                {
                  arg_error|=set_arg(next_arg,argv[i]);
                  next_arg=0;
                }

      if (next_arg)
        {
          //fprintf(stderr,"No value for arg %c\n",next_arg);
          next_arg=0;
          arg_error=1;
        };

   if (!bmdefault)
     bmdefault=_BACKUP_DAT;

	strcpy(backup_mem,short_exe_name);
	strcat(backup_mem,bmdefault);

   sprintf(sav_path,"%sSAV/",short_exe_name);
   if (!file_exists(sav_path,FA_DIREC,0))
     mkdir(sav_path,0);

   atexit(TrashSound);
   // In case of crash, try to free as many resources as we can


//	destroy_bitmap(XBuf);
	getkey();
   (*fade_out_proc[rand()%nb_fadeout])(0,0,320,200);


	BaseClock = 7800000;//7160000; //3.58-21.48;
	//  7.8 Mhz  ^

	LOCK_VARIABLE(key_delay);
   LOCK_VARIABLE(timer_60);
	LOCK_VARIABLE(can_blit);
	LOCK_FUNCTION(interrupt_60hz);

	IPeriod	= BaseClock/(scanlines_per_frame*60);
#ifndef FINAL_RELEASE
	fprintf(stderr,"IPeriod = %d\n", IPeriod);
#endif
//	UPeriod = 0;
	TimerPeriod = BaseClock/1000*3*1024/21480;
#ifndef FINAL_RELEASE
	fprintf(stderr,"TimerPeriod = %d\n", TimerPeriod);
#endif

   	install_timer();
	if (!InitMachine()) return -1;

   do {
   if (!cart_name)
     cart_name=(char*)select_rom("*.pce");
   if (strcmp(cart_name,"NO FILE"))
	if (!InitPCE(cart_name, backup_mem))
     {
      effectively_played=1;
      cart_reload=0;
	 install_int_ex(interrupt_60hz,BPS_TO_TIMER(60));
		RunPCE();
	 remove_int(interrupt_60hz);

	   TrashPCE(backup_mem);
	 }
   }
   while (cart_reload);
	TrashMachine();

      #ifdef ALLEGRO
	allegro_exit();
      #endif

   if (effectively_played)
     {
      if (NO_ROM<NB_ROM)
	printf("You played %s.\nThank you very much.\nSee you soon.\n",ROM_LIST[NO_ROM].name);
      else
	printf("Unknown ROM\nIf you want to make the science progress\nPlease contact me at OJOLLY@HOTMAIL.COM ;)\nI'd be interested in having it.");
     }
   else
     printf("See Ya!\n");
      #ifdef CHRONO
	if (!(F	= fopen("RESULT.DAT","wt+")))
	  return -1;
	for (vmode=0;vmode<256;vmode++)
	  {
	   fprintf(F,"Inst 0X%02X : %10u calls, %10u (*840)ns => avr. of %10u (*840)ns\n",vmode,nb_used[vmode],time_used[vmode],(nb_used[vmode]?time_used[vmode]/nb_used[vmode]:0));
	   if (nb_used[vmode]>=timax)
	     {
	      inst_max=vmode;
	      timax=nb_used[vmode];
	      }
	  };
      fprintf(F,"\nGreat Winner is inst 0X%02X with %10u calls and %10u (*840)ns elapsed => average of %10u",inst_max,nb_used[inst_max],time_used[inst_max],time_used[inst_max]/nb_used[inst_max]);
      fclose(F);

      #endif

      if (timer_60)
	     {
         fprintf(stderr,"time elapsed : %f\n",(timer_60/60.0));
	      fprintf(stderr,"frame per sec. : %f\n",frame/(timer_60/60.0));
        }
      fclose(out_snd);
      return 0;
}
