// pce.h
#ifndef _INCLUDE_PCE_H
#define _INCLUDE_PCE_H

#define	WIDTH	(360+64)
#define	HEIGHT	256

#include <crt0.h>
#include <conio.h>
#include <sys/timeb.h>
#include <dir.h>
#include	<stdio.h>
#include	<stdlib.h>
#include "M6502.h"
#include "gui.h"

typedef struct tagIO {
	pair VDC[32];
//	byte VDC_ratch[32];
	pair VCE[0x200];
	pair vce_reg;
	/* VDC */
	word vdc_inc,vdc_raster_count;
	byte vdc_reg,vdc_status,vdc_ratch,vce_ratch;
//	byte vdc_iswrite_h;
	byte vdc_satb;
	byte vdc_pendvsync;
	int bg_h,bg_w;
	int screen_w,screen_h;
	int scroll_y;
	int minline, maxline;
	/* joypad */
	byte JOY[16];
	byte joy_select,joy_counter;
	/* PSG */
	byte PSG[6][8],wave[6][32],wavofs[6];
        // PSG STRUCTURE
        // 0 : dda_out
        // 2 : freq (lo byte)  | In reality it's a divisor
        // 3 : freq (hi byte)	 | 3.7 Mhz / freq => true snd freq
        // 4 : dda_ctrl
        //     000XXXXX
        //     ^^  ^
        //     ||  ch. volume
        //     ||
        //     |direct access (everything at byte 0)
        //     |
        //    enable
        // 5 : pan (left vol = hi nibble, right vol = low nibble)
        // 7 : noise_ctrl
	byte psg_ch,psg_volume,psg_lfo_freq,psg_lfo_ctrl;
	/* TIMER */
	byte timer_reload,timer_start,timer_counter;
	/* IRQ */
	byte irq_mask,irq_status;
	/* CDROM extention */
	int backup,adpcm_firstread;
	pair adpcm_ptr;
	word adpcm_rptr,adpcm_wptr;
} IO;

//typedef char BOOL;
//typedef unsigned char BYTE;

     #define min(a,b) \
       ({typedef _ta = (a), _tb = (b);  \
         _ta _a = (a); _tb _b = (b);     \
         _a < _b ? _a : _b; })

     #define max(a,b) \
       ({typedef _ta = (a), _tb = (b);  \
         _ta _a = (a); _tb _b = (b);     \
         _a > _b ? _a : _b; })


void PutImage();
int CartLoad(char *name);
void ResetPCE(M6502 *M);
int InitMachine(void);
void TrashMachine(void);
int Joysticks(void);
void set_message(char*);


#define J_UP      0
#define J_DOWN    1
#define J_LEFT    2
#define J_RIGHT   3
#define J_I       4
#define J_II      5
#define J_SELECT  6
#define J_START   7
#define J_AUTOI   8
#define J_AUTOII  9

#include	"list_rom.h" // List of known rom

#include	</djgpp/audio/include/audio.h> // SEAL include

#ifdef SOUND
#include	"sound.h"
#endif // SOUND

#ifdef ALLEGRO
#undef VGA
#define	alleg_mouse_unused
//#define alleg_timer_unused
#define	alleg_joystick_unused
#define	alleg_flic_unused
#define	alleg_sound_unused
//#define alleg_file_unused
//#define alleg_datafile_unused
#define	alleg_gui_unused

#include <allegro.h>

#endif


#ifndef	TRUE
#define	TRUE	1
#define	FALSE	0
#endif

#endif
