/*
 * SvgaAllg.c - a Driver used to replace Linux SVGALib
 *
 * Heavily derived from code by Marat Fayzullin.
 * Modified BERO for NES emulator
 *
 * Adapted by Zeograd (Olivier Jolly) for using Allegro
 *
 */

#ifdef ALLEGRO
#undef VGA
/* Standard and Allegro includes */

#include <stdio.h>
#include <stdlib.h>
#include <audio.h>
#include "allegro.h"
#include "pce.h"
#include "gui.h"

/* Miscellaneous variables/functions */

#define WIDTH (320+64)
#define HEIGHT 256


#define SOUND_BUF_MS 200
#define SBUF_SIZE_BYTE  22050*SOUND_BUF_MS/1000

extern char* sbuf[6];//[6][SBUF_SIZE_BYTE];
//extern unsigned short sbuf[6][SBUF_SIZE_BYTE];
// temporary

BITMAP *XBuf;
// The screen buffer where we draw before blitting it on screen

char *MESSAGE[]={
     "ALL FRAMES DRAWN",
     "FRAME SKIP : 16",
     "FULL SPEED",
     "SYNCHRONISATION TO 60HZ",
     "SCREEN SHOT SAVED IN PICTXXXX.PCX",
     "GAME STATE SAVED",
     "GAME STATE RESTORED",
	  "DUMPING SOUND BEGAN",
	  "DUMPING SOUND ENDED"};
// predefined messages to display

extern char key_delay;
// are we allowed to press another 'COMMAND' key ?

extern char can_blit;
// can we draw or not ? (that's all the question)

// static int changepal;
// may be used later to make cleaner code (maybe faster)

// static int CPURunning;
// Is pce running (that was hard...), Not used

char dump_snd = 0;
// Do we write sound to file

char synchro=0;
//  fond,  fond,  fond? (french joke ;)

extern unsigned char message_delay;
// must we draw the message

int vwidth,vheight;
// size of visible part of the screen (I got troubles with allegro screen->? values!)

int blit_x,blit_y;
// where must we blit the screen buffer on screen

BITMAP *MESSAGE_SPR=0;
// the bitmap containing the message to display (avoid textout each frame)

int vmode=0;
// video mode to use
// 0 -> first 256*240 then 256*256 and 320*200
// 1 -> 256*256 then 320*200
// 2 -> only try 320*200
// If you think others modes would be interesting, let me know

extern char silent;
// use sound?

// void OnBreak(int Arg){ set_gfx_mode(GFX_TEXT,0,0,0,0); CPURunning=0; }
// formely used to answer to ctrl-C

void SetPalette(void)
{
	int i;
   RGB r;
//        r.g=r.b=r.r=0xff;
  //      set_color(0,&r);

	for(i=0;i<255;i++)
           {
                r.r=(i&0x1c)<<1;
                r.g=(i&0xe0)>>2;
                r.b=(i&0x03)<<4;
	  	set_color(i,&r);
           }

}
// this function doesn't work too good, try not to load the intro piccy
// you will have some mess in colors. Play with it if you want, it mustn't
// be too hard to solve (I'm really lazy sometimes)

extern M6502 M;
extern FILE* output_exl;
//extern char* sbuf[6];
extern unsigned dwNewPos;
extern LPAUDIOWAVE lpWave;
extern HAC hVoice;
extern char main_buf[];
extern FILE * out_snd;

void PutImage(void)
{
 static old=0;
 int dum;

 blit(XBuf,screen,84,0,blit_x,blit_y,WIDTH+40,240);

 if (message_delay)
   draw_sprite(screen,MESSAGE_SPR,blit_x+8,min(230+blit_y,vheight-10));

 //fprintf(output_exl,"%u,\n",(unsigned )M.User-old);
 //old=(unsigned)M.User;
/* {
	unsigned	dum;
	unsigned tmp;
	for (dum=0;dum<dwNewPos;dum++)
    {
		tmp=(sbuf[0][dum]+sbuf[1][dum]+sbuf[2][dum]+sbuf[3][dum]+sbuf[4][dum]+sbuf[5][dum])/6;
		putc(tmp,output_exl);
    }
//   fwrite(sbuf[1],1,dwNewPos,output_exl);
 }*/
 if (synchro)
	{
     asm ("begin_sync:
         call _pause
         movb _can_blit,%al
         testb %al,%al
         je begin_sync");
	  can_blit=0;
   }

  if (!silent)
	 {
		char ch;
      for (ch=0;ch<6;ch++ )
		 {
	      write_psg(ch);
//			for (dum=0;dum<dwNewPos;dum++)
	//			fprintf(stderr,"CH %d : %d\n",ch,sbuf[ch][dum]);
			//fprintf(stderr,"OUT : sbuf[ch] = %p\n",sbuf[ch]);
       }

/*      if (!dwNewPos)
		  {
		    fprintf(stderr,"dwNewPos NUL!!!!!");
			 exit(15);
        }*/
      for (dum=0;dum<dwNewPos;dum++)
		  {
			//fprintf(stderr,"%3d %3d %3d %3d %3d %3d\n",sbuf[0][dum],sbuf[1][dum],sbuf[2][dum],sbuf[3][dum],sbuf[4][dum],sbuf[5][dum]);
			main_buf[dum]=(sbuf[0][dum]+sbuf[1][dum]+sbuf[2][dum]+sbuf[3][dum]+sbuf[4][dum]+sbuf[5][dum])>>2 ;
			}
			//lpWave->lpData[dum]=-0x60+(sbuf[0][dum]+sbuf[1][dum]+sbuf[2][dum]+sbuf[3][dum]+sbuf[4][dum]+sbuf[5][dum])>>1;
		if (dump_snd)
        fwrite(main_buf,1,dwNewPos,out_snd);
		  //fwrite(sbuf[5],1,dwNewPos,out_snd);
//		for (can_blit=0;can_blit<6 ;can_blit++ )
//			{
            //lpWave->lpData = main_buf;
/*			  if (next==0)
             {
				   long dum;
				   memcpy(lpWave->lpData,main_buf,dwNewPos);
					do
                 {
						 AGetVoicePosition(hVoice,&dum);
                   AUpdateAudio();
						 fprintf(stderr,"1 : %d / %d\n",dum,old);
                 }
               while (dum<old-10);

					AWriteAudioData(lpWave, 0L, lpWave->dwLength);
					ASetVoicePosition(hVoice,0);
					old=dwNewPos;
					next=dwNewPos;
             }
           else
             {
				   long dum;
				   memcpy(&lpWave->lpData[next],main_buf,dwNewPos);
					do
                 {
						 AGetVoicePosition(hVoice,&dum);
						 AUpdateAudio();
						 fprintf(stderr,"2 : %d / %d\n",dum,old);
                 }
               while (dum<old-10);
					lpWave->dwLoopEnd=next+dwNewPos+1;

					AWriteAudioData(lpWave, 0 ,lpWave->dwLength);
					ASetVoicePosition(hVoice,next);
					old=next+dwNewPos+1;
					next=0;
             }
  */


				{
				 long dum;
				 do
				  {
					AGetVoicePosition(hVoice,&dum);
//					fprintf(stderr,"%d / %d\n",dum,old);
					AUpdateAudio();
              }
             while (dum<old-10);
				 }


		      memcpy(lpWave->lpData,main_buf,lpWave->dwLength);
				//memcpy(lpWave->lpData,sbuf[2],lpWave->dwLength);
				lpWave->dwLoopEnd = dwNewPos;
            AWriteAudioData(lpWave, 0L, lpWave->dwLength);

		      ASetVoicePosition(hVoice,0);
				old=dwNewPos;
  //       }

      AUpdateAudio();
    }
  // it doesn't work too bad because this function is regulary called

}

/* TrashMachine - Uninitialise everything */
void TrashMachine(void)
{

 #ifdef SOUND
   TrashSound();
 #endif

 (*fade_out_proc[rand()%nb_fadeout])(blit_x,blit_y,vwidth,vheight);

 destroy_bitmap(XBuf);
 if (MESSAGE_SPR)
   destroy_bitmap(MESSAGE_SPR);

 set_gfx_mode(GFX_TEXT,0,0,0,0);

 return ;
}


/* InitMachine - Starts up all the stuff */
int InitMachine(void)
{
 set_gfx_mode(GFX_TEXT,0,0,0,0);
 printf("  Initialising Dos/VGA Allegro driver.\n  Allocating buffers...");
 
 if (!(XBuf=create_bitmap(WIDTH+40,HEIGHT)))
  {
   printf("\n FAILED\n");
   return 0;
  }

 printf("OK\n  Clearing main buffer\n");
   clear(XBuf);
 printf("  Redirecting timer interrupt\n");
	install_timer();
 printf("  Redirecting keyboard interrupt\n");
   install_keyboard();

#ifdef SOUND
 printf("  Initing sound...\n");
 InitSound();
#endif SOUND
 

            if ((vmode==0) && (!set_gfx_mode(GFX_AUTODETECT,256,240,0,0)))
            {
             vwidth=256;
             vheight=240;
             blit_x=0;
             blit_y=0;
             }
            else
            if ((vmode<=1) && (!set_gfx_mode(GFX_AUTODETECT,256,256,0,0)))
            {
             vwidth=256;
             vheight=256;
             blit_x=0;
             blit_y=8;
             }
            else
            if ((vmode<=2) && (!set_gfx_mode(GFX_AUTODETECT,320,200,0,0)))
            {
             vwidth=320;
             vheight=200;
             blit_x=32;
             blit_y=-10;
             set_clip(screen,0,0,255+blit_x,199);
             }
            else
            {
             printf("  Can't set graphic mode!!");
             return 0;
             }

// textout(screen,font,"OK\n Allocating colors...\n",0,0,1);
 SetPalette();


 clear(screen);
 return 1;
}

/*****************************************************************************

    Function:  savepict

    Description:save the current screen
    Parameters:none
    Return:the number of the saved piccy

*****************************************************************************/


unsigned short savepict()
  {
          BITMAP *bmp;
          PALETTE pal;
          char* final="PICT0000.PCX";
          short unsigned tmp=0;

          while ((tmp!=0xFFFF) && (exists(final)))
              sprintf(final,"PICT%04X.PCX",++tmp);
          if (tmp==0xFFFF)
            return tmp;

          get_palette(pal);
          bmp = create_sub_bitmap(screen, 0, 0, min(screen->w,WIDTH), min(screen->h,HEIGHT));
          save_bitmap(final, bmp, pal);
          destroy_bitmap(bmp);
          //fprintf(stderr,"picture saved %s\n",final);
          return tmp;

   }

void set_message(char* mess)
{
 if (MESSAGE_SPR)
   destroy_bitmap(MESSAGE_SPR);
 MESSAGE_SPR=create_bitmap(text_length(font,mess)+1,text_height(font)+1);
 clear(MESSAGE_SPR);

 textout(MESSAGE_SPR,font,mess,1,1,1);
 textout(MESSAGE_SPR,font,mess,0,0,255);
 return;
 }
// Create a sprite containig the message to display on screen

/* Joysticks - Handles input. Due to differences between SVGAlib and X, this
 * may be a bit bonkers. You have been warned. Due to SVGAlib, and my 
 * laziness, only a select few keys are supported. But anyway, the key 
 * mappings I have dropped are nasty, horrid ones. So don't worry.
 */
// precedent note is no more available ;)
// Keys are great (if I say it is, it's true [of course!] )
// but still predefined, I will fix it later (certainly with the GUI)

#define	JOY_A		0x01
#define	JOY_B		0x02
#define	JOY_SELECT	0x04
#define	JOY_START	0x08
#define	JOY_UP		0x10
#define	JOY_RIGHT	0x20
#define	JOY_DOWN	0x40
#define	JOY_LEFT	0x80



extern unsigned int dwOldPos[6];
extern int UPeriod;
extern unsigned char nb_joy;
extern IO io;
extern unsigned char joy_mapping[5][10];
extern char cart_reload;

void pokebyte();
char savegame();
char loadgame();
char searchbyte();

int Joysticks(void)
{
 //static int JS = 0x0000;
  //JS = 0;
 char tmp_joy;
 
 if(( key[KEY_ESC] ) && (!key_delay))
	{
     //menu(); //There will be the GUI
	  while (keypressed())
		 readkey();
	  select_rom("*.pce");
	  while (keypressed())
		 readkey();
     key_delay=10;

	  if (strcmp("NO FILE",selected_rom))
		 {
		   cart_reload=1;
			return 1;
       }
   }
 if( key[KEY_F12] )
   //JS|=0x10000;
	return 1;
 if( key[KEY_F6] )
   {
//	  unsigned  vol;
	  if (!silent)
		 {
//	      AGetVoiceVolume(hVoice,&vol);
//	      ASetVoiceVolume(hVoice,0);
			AStopVoice(hVoice);
			lpWave->dwLoopEnd=0;
			ASetVoicePosition(hVoice,0);
			AUpdateAudio();
       }
     if (!savegame());
       set_message(MESSAGE[5]);
     message_delay=180;

	  if (!silent)
		 {
//     	  ASetVoiceVolume(hVoice,vol);
			lpWave->dwLoopEnd=lpWave->dwLength;
			ASetVoicePosition(hVoice,0);

		  AStartVoice(hVoice);

		  AUpdateAudio();

       }

   };
 if( key[KEY_F7] )
   {
     if (!loadgame());
       set_message(MESSAGE[6]);
     message_delay=180;
   };
 if( key[KEY_F5] )
   if (!key_delay)
     {
       sprintf(MESSAGE[4],"SCREEN SHOT SAVED IN PICT%04X.PCX",savepict());
       set_message(MESSAGE[4]);
       message_delay=180;
       key_delay=10;
     };
 if( key[KEY_F1] )
  {
   searchbyte();
   //return JS;
	return 0;
  }
 if( key[KEY_F2] )
  {
   pokebyte();
   //return JS;
	return 0;
  }
 if( key[KEY_F10])
    if (!key_delay)
      {
        synchro=!synchro;
        set_message(MESSAGE[2+synchro]);
        message_delay=180;
        key_delay=10;
      };
 if( key[KEY_NUMLOCK])
	if (!key_delay)
	  {
		if (dump_snd)
		  {
			fclose(out_snd);
			set_message(MESSAGE[8]);
			}
      else
		  {
			unsigned	short tmp=0;
			char tmp_buf[128]="SND0000.PCM";

			while ((tmp<0xFFFF) && (exists(tmp_buf)))
			  sprintf(tmp_buf,"SND%04X.PCM",++tmp);

			out_snd=fopen(tmp_buf,"wb");
			set_message(MESSAGE[7]);
			}
      dump_snd=!dump_snd;
		key_delay=10;
		message_delay=180;
		}
 if( key[KEY_PLUS_PAD])
    if (!key_delay)
      {
        if (UPeriod<15)
          {
            UPeriod++;
				sprintf(MESSAGE[1],"FRAME SKIP : %d",UPeriod);
            set_message(MESSAGE[1]);
            message_delay=180;
          };
        key_delay=10;
      };
 if( key[KEY_MINUS_PAD])
    if (!key_delay)
      {
        if (UPeriod)
          {
            UPeriod--;
				if (!UPeriod)
              set_message(MESSAGE[0]);
            else
				  {
				    sprintf(MESSAGE[1],"FRAME SKIP : %d",UPeriod);
					 set_message(MESSAGE[1]);
              };
            message_delay=180;
          };
        key_delay=10;
      };
#ifdef SOUND
/* if( key[KEY_PLUS_PAD] )
    {
      FILE *F=fopen("wav.dat","wb");
      int i,j;
      unsigned char bigbuf[SBUF_SIZE_BYTE];
      memcpy(bigbuf,sbuf[0],SBUF_SIZE_BYTE);
//      for (i=1;i<6;i++)
//         {
//        for (j=0;j<SBUF_SIZE_BYTE;j++)
//          bigbuf[j]+=sbuf[i][j];
//        fprintf(F,"WAVE DATA CHANNEL %d\n",i);
 //       for (j=0;j<SBUF_SIZE_BYTE;j++)
   //       fprintf(F,"%3i%c",sbuf[i][j],(j%10?' ':'\n'));
//          }
      fwrite(bigbuf,1,SBUF_SIZE_BYTE,F);
      fclose(F);
    }*/
#endif

/*	   //Disabled for new dynamic mapping
 if( (key_shifts&KB_CTRL_FLAG) || key[KEY_Z])	JS|=JOY_B;
 if( (key_shifts&KB_ALT_FLAG) || key[KEY_X] ) JS |= JOY_A;
 if( key[KEY_ENTER] )	JS |= JOY_START;
 if( key[KEY_TAB] || key[KEY_SPACE] )	JS |= JOY_SELECT;

 if( key[KEY_DOWN] )	JS |= JOY_DOWN;
   else
     if( key[KEY_UP] )	JS |= JOY_UP;

 if( key[KEY_LEFT] )	JS |= JOY_LEFT;
   else
     if( key[KEY_RIGHT] )	JS |= JOY_RIGHT;
 */

 // A bit primitive as input but will evolve, I'm looking for a way
 // not to lose speed and increase flexibility (joypads...)

 for (tmp_joy=0;tmp_joy<nb_joy ;tmp_joy++ )
    {
	  io.JOY[tmp_joy]=0;

	  if (key[joy_mapping[tmp_joy][J_DOWN]])
		 io.JOY[tmp_joy]|=JOY_DOWN;
     else
	    if (key[joy_mapping[tmp_joy][J_UP]])
		   io.JOY[tmp_joy]|=JOY_UP;

     if (key[joy_mapping[tmp_joy][J_LEFT]])
		 io.JOY[tmp_joy]|=JOY_LEFT;
     else
       if (key[joy_mapping[tmp_joy][J_RIGHT]])
		   io.JOY[tmp_joy]|=JOY_RIGHT;

     if (key[joy_mapping[tmp_joy][J_II]])
		 io.JOY[tmp_joy]|=JOY_A;

     if (key[joy_mapping[tmp_joy][J_I]])
		 io.JOY[tmp_joy]|=JOY_B;

     if (key[joy_mapping[tmp_joy][J_SELECT]])
		 io.JOY[tmp_joy]|=JOY_SELECT;

     if (key[joy_mapping[tmp_joy][J_START]])
		 io.JOY[tmp_joy]|=JOY_START;

    }

 //return JS;
 return 0;
}
#else // ALLEGRO section ended
  #error include "svga.h" not this one!!!!!!
#endif
